﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CaptchaController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Account
{
    #region usings
    using System.Web.Mvc;

    using Fruitmonitoring.Helper.HtmlExtensions;

    #endregion

    /// <summary>
    /// The captcha controller.
    /// </summary>
    public class CaptchaController : Controller
    {
        #region Properties

        #region Static Fields
        /// <summary>
        /// The captcha name.
        /// </summary>
        public static readonly string CaptchaName = "Captcha";
        #endregion

        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The captcha partial.
        /// </summary>
        /// <param name="options">
        /// The options.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public ActionResult CaptchaPartial(CaptchaOptions options)
        {
            return null;
        }
        #endregion

        #region Nested type: CaptchaOptions
        /// <summary>
        /// The captcha options.
        /// </summary>
        public class CaptchaOptions
        {
            #region Properties
            /// <summary>
            /// Gets the default.
            /// </summary>
            public static CaptchaOptions Default
            {
                get
                {
                    return new CaptchaOptions() { CharacterSet = "ABCDEFGHJKLMNPQRSTUVWXYZabcdefhjkmnpqrstuvwxyz23456789", CodeLength = 5 };
                }
            }

            /// <summary>
            /// Gets the character set.
            /// </summary>
            public string CharacterSet { get; private set; }

            /// <summary>
            /// Gets the code length.
            /// </summary>
            public int CodeLength { get; private set; }
            #endregion
        }
        #endregion
    }
}