﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="TranslationAdminController.cs.cs" company="convivo GmbH">
//    Copyright © 2015 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Admin.Administration
{
    #region usings
    using System;
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Controllers.Interfaces;
    using Fruitmonitoring.Helper.Export;
    using Fruitmonitoring.Helper.HtmlExtensions.TranslationCreator;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;
    using Fruitmonitoring.Models.ViewModels;

    using Languages;

    #endregion

    /// <summary>
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Admin)]
    public class TranslationAdminController : BaseGridViewCustomBindingController, IDataManipulator<MultiTranslationViewModel>, IExportController
    {
        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// </summary>
        public TranslationAdminController()
            : base(
                new TranslationBindingHandlers(),
                GridViewHelper.TRANSLATIONADMINGRIDVIEWID,
                GridViewHelper.GRIDVIEWCOMPONENTSPATH + "Translation/_translationGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Translation.Translation_id),
                GridViewHelper.TRANSLATIONADMINCONTROLLERNAME,
                new USP_Translation_Sel_Result().GetType(),
                true,
                false)
        {
        }
        #endregion

        #endregion

        #region IExportController Members

        #region Public Methods and Operators

        #region actionresults
        /// <summary>
        /// </summary>
        /// <param name="exportType">
        /// </param>
        /// <param name="columnNames">
        /// </param>
        /// <param name="columnTexts">
        /// </param>
        /// <param name="filter">
        /// </param>
        /// <param name="sortColumnName">
        /// </param>
        /// <param name="sortOrder">
        /// </param>
        /// <param name="applySorting">
        /// </param>
        /// <param name="applyFilter">
        /// </param>
        /// <returns>
        /// </returns>
        [HttpPost]
        public ActionResult Export(
            string exportType,
            string columnNames,
            string columnTexts,
            string filter,
            string sortColumnName,
            string sortOrder,
            bool applySorting,
            bool applyFilter)
        {
            return null;
        }
        #endregion

        #endregion

        #endregion

        #region IDataManipulator Member
        /// <summary>
        /// </summary>
        /// <returns>
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult Add()
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="model">
        /// </param>
        /// <returns>
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Add(MultiTranslationViewModel model)
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="id">
        /// </param>
        /// <returns>
        /// </returns>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(Guid id)
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="model">
        /// </param>
        /// <returns>
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(MultiTranslationViewModel model)
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="id">
        /// </param>
        /// <returns>
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Delete(Guid id)
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="properties">
        /// </param>
        public void LoadAddAndEditViewData(object properties = null)
        {
        }
        #endregion
    }
}