﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="RetailerToSupplierAdminController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Admin.CustomerMasterdata
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Controllers.Interfaces;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Helper.Utility.ExtensionHelper;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The retailer to supplier admin controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Admin)]
    public class RetailerToSupplierAdminController : BaseGridViewCustomBindingController, IDataManipulator<SupplierMappingModel<USP_Company_Sel_Result>>
    {
        #region Properties

        #region Static Fields
        /// <summary>
        /// The checkboxcontainer.
        /// </summary>
        public static readonly string CHECKBOXCONTAINER = "RetailerToSupplierMapping";
        #endregion

        #region Fields
        /// <summary>
        /// The _ check box list extension.
        /// </summary>
        private ICheckBoxListExtensionHelper _CheckBoxListExtension = new CheckBoxListExtensionHelper();
        #endregion

        #endregion

        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="RetailerToSupplierAdminController"/> class.
        /// </summary>
        public RetailerToSupplierAdminController()
            : base(
                new CompanyBindingHandlers(
                    new Dictionary<string, object>()
                    {
                        {
                            CompanyBindingHandlers.PROPERTYKEY_COMPANYTYPEIDLIST,
                            DbGuidHelper.GetCompanyTypeId(DbGuidHelper.CompanyTypes.RETAILERCOMPANY)
                        },
                        { CompanyBindingHandlers.PROPERTYKEY_COMPANYSTATUSID, null }
                    }),
                GridViewHelper.RETAILERTOSUPPLIERADMINGRIDVIEWID,
                GridViewHelper.GRIDVIEWCOMPONENTSPATH + "Company/_retailerToSupplierGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Company.Company_id),
                GridViewHelper.RETAILERTOSUPPLIERADMINCONTROLLERNAME,
                EFHelper.Usp_Company.GetType(),
                true,
                false)
        {
        }
        #endregion

        #endregion

        #region IDataManipulator<SupplierMappingModel<USP_Company_Sel_Result>> Members

        #region Public Methods and Operators

        #region IDataManipulator Member
        /// <summary>
        /// The load add and edit view data.
        /// </summary>
        /// <param name="properties">
        /// The properties.
        /// </param>
        public void LoadAddAndEditViewData(object properties = null)
        {
        }
        #endregion

        #endregion

        #endregion

        #region IDataManipulator<SupplierMappingModel> Member
        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="id">
        /// The id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(Guid id)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(SupplierMappingModel<USP_Company_Sel_Result> model)
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public ActionResult Add()
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public ActionResult Add(SupplierMappingModel<USP_Company_Sel_Result> model)
        {
            return null;
        }

        /// <summary>
        /// The delete.
        /// </summary>
        /// <param name="id">
        /// The id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public ActionResult Delete(Guid id)
        {
            return null;
        }
        #endregion
    }
}