﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="PrivateBrandAdminController.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Admin.Masterdata
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Controllers.Interfaces;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.ViewModels;

    #endregion

    /// <summary>
    /// The private brand admin controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Admin)]
    public class PrivateBrandAdminController : BaseGridViewController, IDataManipulator<USP_PrivateBrand_Sel_Result>, IExportController
    {
        #region Properties

        #region Constants
        /// <summary>
        /// The checkboxcontainer.
        /// </summary>
        public const string CHECKBOXCONTAINER = "PrivateBrandsMapping";
        #endregion

        #region Fields
        private readonly string gridViewPartialFile = "PrivateBrand/_privateBrandGridViewPartial";
        #endregion

        #endregion

        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateBrandAdminController"/> class.
        /// </summary>
        public PrivateBrandAdminController()
            : base(GridViewHelper.PRIVATEBRANDADMINCONTROLLERNAME, GridViewHelper.PRIVATEBRANDADMINGRIDVIEWID, true, false)
        {
        }
        #endregion

        #endregion

        #region IDataManipulator<USP_PrivateBrand_Sel_Result> Members

        #region Public Methods and Operators

        #region IDataManipulator Member
        /// <summary>
        /// The load add and edit view data.
        /// </summary>
        /// <param name="properties">
        /// The properties.
        /// </param>
        public void LoadAddAndEditViewData(object properties = null)
        {
        }
        #endregion

        #endregion

        #endregion

        #region actionresults
        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public override ActionResult GridViewListView()
        {
            return null;
        }

        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public override ActionResult GridViewListViewInit()
        {
            return null;
        }

        /// <summary>
        /// The export.
        /// </summary>
        /// <param name="exportType">
        /// The export type.
        /// </param>
        /// <param name="columnNames">
        /// The column names.
        /// </param>
        /// <param name="columnTexts">
        /// The column texts.
        /// </param>
        /// <param name="filter">
        /// The filter.
        /// </param>
        /// <param name="sortColumnName">
        /// The sort column name.
        /// </param>
        /// <param name="sortOrder">
        /// The sort order.
        /// </param>
        /// <param name="applySorting">
        /// The apply sorting.
        /// </param>
        /// <param name="applyFilter">
        /// The apply filter.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        public ActionResult Export(
            string exportType,
            string columnNames,
            string columnTexts,
            string filter,
            string sortColumnName,
            string sortOrder,
            bool applySorting,
            bool applyFilter)
        {
            return null;
        }
        #endregion

        #region IDataManipulator<USP_PrivateBrand_Sel_Result> Member
        /// <summary>
        /// The add.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult Add()
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Add(USP_PrivateBrand_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="id">
        /// The id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(Guid id)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(USP_PrivateBrand_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// Delete private brand.
        /// </summary>
        /// <param name="id">
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Delete(Guid id)
        {
            return null;
        }
        #endregion

        #region additional Actions
        /// <summary>
        /// Prepares PrivateBrand selections for view.
        /// </summary>
        /// <param name="id">
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpGet]
        [AjaxOrChildActionOnly]
        public ActionResult MapRetailersToPrivateBrand(Guid id)
        {
            return null;
        }

        /// <summary>
        /// Saves PrivateBrand selections to db.
        /// </summary>
        /// <param name="privateBrandId">
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        public ActionResult MapRetailersToPrivateBrand(string privateBrandId)
        {
            return null;
        }

        /// <summary>
        /// Takes retailers, regions, and selections and returns the (inner) view model.
        /// </summary>
        /// <param name="allRetailers">
        /// </param>
        /// <param name="allRegions">
        /// </param>
        /// <param name="selectedCompanies">
        /// </param>
        /// <returns>
        /// An ordered list of retailers and regions and if they are selected.
        /// </returns>
        private List<PrivateBrandCompanyViewModel> getMappedRetailerCompanies(
            List<USP_Company_Sel_Result> allRetailers,
            List<USP_Company_Sel_Result> allRegions,
            List<USP_PrivateBrandShow_Sel_Result> selectedCompanies)
        {
            var mappedRetailerCompanies = new List<PrivateBrandCompanyViewModel>();
            foreach (var retailer in allRetailers)
            {
                var isSelected = selectedCompanies.Any(x => x.Company_id == retailer.Company_id);
                var mappedCompany = new PrivateBrandCompanyViewModel(retailer.Company_id, retailer.CompanyName, null, isSelected);
                mappedRetailerCompanies.Add(mappedCompany);

                var regionsForThisRetailer =
                    allRegions.Where(v => v.CompanyRef_Company_id == retailer.Company_id).OrderBy(v => v.CompanyName).ToList<USP_Company_Sel_Result>();

                foreach (var region in regionsForThisRetailer)
                {
                    var isSelectedRegion = selectedCompanies.Any(x => x.Company_id == region.Company_id);
                    var mappedRegion = new PrivateBrandCompanyViewModel(region.Company_id, region.CompanyName, region.CompanyRef_Company_id, isSelectedRegion);
                    mappedRetailerCompanies.Add(mappedRegion);
                }
            }

            return mappedRetailerCompanies;
        }
        #endregion
    }
}