﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="InvestigationOrderArchiveController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Common
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using DevExpress.Data.Filtering;
    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    using Languages.Pages.Common.InvestigationOrderArchive;

    #endregion

    /// <summary>
    /// The investigation order archive controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Orderer)]
    public class InvestigationOrderArchiveController : BaseInvestigationOrderController
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="InvestigationOrderArchiveController"/> class.
        /// </summary>
        public InvestigationOrderArchiveController()
            : base(
                new SampleInvestigationOrderBindingHandlers(
                    new Dictionary<string, object>() { { SampleInvestigationOrderBindingHandlers.PROPERTYKEY_USEUSERCOMPANYID, true } }),
                GridViewHelper.INVESTIGATIONORDERARCHIVECOMMONGRIDVIEWID,
                GridViewHelper.GRIDVIEWCOMPONENTSPATH + "SampleInvestigationOrder/_sampleInvestigationOrderArchiveGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Sample_Investigation.Sample_id),
                GridViewHelper.INVESTIGATIONORDERARCHIVECOMMONCONTROLLERNAME)
        {
        }
        #endregion

        #region Methods
        /// <summary>
        /// The get fixed filter expression.
        /// </summary>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        private string getFixedFilterExpression()
        {
            return null;
        }
        #endregion

        #region Public Methods and Operators

        #region additional actionresults
        /// <summary>
        /// The cancel investigation order.
        /// </summary>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult CancelInvestigationOrder(Guid sampleId)
        {
            return null;
        }
        #endregion

        #region overrides
        /// <summary>
        /// The custom binding core.
        /// </summary>
        /// <param name="gridViewModel">
        /// The grid view model.
        /// </param>
        /// <param name="sortColumn">
        /// The sort column.
        /// </param>
        /// <param name="oldPageSize">
        /// The old page size.
        /// </param>
        /// <returns>
        /// The <see cref="PartialViewResult"/>.
        /// </returns>
        [NonAction]
        public override PartialViewResult CustomBindingCore(GridViewModel gridViewModel, GridViewColumnState sortColumn = null, int oldPageSize = -1)
        {
            return null;
        }
        #endregion

        #endregion
    }
}