﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseCompanyController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Helper.Export;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;
    using Fruitmonitoring.Models.ComboBox;

    #endregion

    /// <summary>
    /// The base company controller.
    /// </summary>
    public class BaseCompanyController : BaseGridViewCustomBindingController
    {
        #region Properties
        /// <summary>
        /// Gets or sets the binding handler.
        /// </summary>
        private IBindingHandler bindingHandler { get; set; }
        #endregion

        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="BaseCompanyController"/> class.
        /// </summary>
        /// <param name="bindingHandler">
        /// The binding handler.
        /// </param>
        /// <param name="gridViewId">
        /// The grid view id.
        /// </param>
        /// <param name="gridViewPartialPath">
        /// The grid view partial path.
        /// </param>
        /// <param name="keyFieldName">
        /// The key field name.
        /// </param>
        /// <param name="activeControllerName">
        /// The active controller name.
        /// </param>
        /// <param name="modelType">
        /// The model type.
        /// </param>
        /// <param name="isAdmin">
        /// The is admin.
        /// </param>
        /// <param name="isSuperUser">
        /// The is super user.
        /// </param>
        public BaseCompanyController(
            IBindingHandler bindingHandler,
            string gridViewId,
            string gridViewPartialPath,
            string keyFieldName,
            string activeControllerName,
            Type modelType,
            bool isAdmin,
            bool isSuperUser)
            : base(bindingHandler, gridViewId, gridViewPartialPath, keyFieldName, activeControllerName, modelType, isAdmin, isSuperUser)
        {
            this.bindingHandler = bindingHandler;
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The add company types to view data.
        /// </summary>
        public void AddCompanyTypesToViewData()
        {
        }

        #region Override Member
        /// <summary>
        /// The custom binding core.
        /// </summary>
        /// <param name="gridViewModel">
        /// The grid view model.
        /// </param>
        /// <param name="sortColumn">
        /// The sort column.
        /// </param>
        /// <param name="oldPageSize">
        /// The old page size.
        /// </param>
        /// <returns>
        /// The <see cref="PartialViewResult"/>.
        /// </returns>
        public override PartialViewResult CustomBindingCore(GridViewModel gridViewModel, GridViewColumnState sortColumn = null, int oldPageSize = -1)
        {
            return null;
        }
        #endregion

        #region actionresults
        /// <summary>
        /// The export.
        /// </summary>
        /// <param name="exportType">
        /// The export type.
        /// </param>
        /// <param name="columnNames">
        /// The column names.
        /// </param>
        /// <param name="columnTexts">
        /// The column texts.
        /// </param>
        /// <param name="filter">
        /// The filter.
        /// </param>
        /// <param name="sortColumnName">
        /// The sort column name.
        /// </param>
        /// <param name="sortOrder">
        /// The sort order.
        /// </param>
        /// <param name="applySorting">
        /// The apply sorting.
        /// </param>
        /// <param name="applyFilter">
        /// The apply filter.
        /// </param>
        /// <param name="companyStatusId">
        /// The status of the companies that should be selected. Insert "NULL" to get all companies.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        public ActionResult ExportCompaniesWithSpecificStatus(
            string exportType,
            string columnNames,
            string columnTexts,
            string filter,
            string sortColumnName,
            string sortOrder,
            bool applySorting,
            bool applyFilter,
            Guid? companyStatusId)
        {
            return null;
        }
        #endregion

        /// <summary>
        /// Gets all possible company types (admin).
        /// </summary>
        /// <returns>
        /// The <see cref="List"/>.
        /// </returns>
        public virtual List<USP_CompanyType_Sel_Result> getCompanyTypes()
        {
            return null;
        }
        #endregion
    }
}