﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseParameterGroupController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    using ParameterGroup = Languages.Pages.AllAreas.ParameterGroup.ParameterGroup;

    #endregion

    /// <summary>
    /// The base parameter group controller.
    /// </summary>
    public abstract class BaseParameterGroupController : BaseGridViewCustomBindingController
    {
        #region Properties

        #region variables
        /// <summary>
        /// Gets or sets the active controller name.
        /// </summary>
        private string activeControllerName { get; set; }
        #endregion

        #endregion

        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="BaseParameterGroupController"/> class.
        /// </summary>
        /// <param name="bindingHandler">
        /// The binding handler.
        /// </param>
        /// <param name="gridViewId">
        /// The grid view id.
        /// </param>
        /// <param name="gridViewPartialPath">
        /// The grid view partial path.
        /// </param>
        /// <param name="keyFieldName">
        /// The key field name.
        /// </param>
        /// <param name="activeControllerName">
        /// The active controller name.
        /// </param>
        public BaseParameterGroupController(
            IBindingHandler bindingHandler,
            string gridViewId,
            string gridViewPartialPath,
            string keyFieldName,
            string activeControllerName)
            : base(
                bindingHandler,
                gridViewId,
                gridViewPartialPath,
                keyFieldName,
                activeControllerName,
                new USP_ParameterGroup_Sel_Result().GetType(),
                true,
                false)
        {
            this.activeControllerName = activeControllerName;
        }
        #endregion

        #endregion

        #region Public Methods and Operators

        #region methods
        /// <summary>
        /// Render the "show detail" button.
        /// </summary>
        /// <param name="actionUrl">
        /// </param>
        /// <returns>
        /// The <see cref="GridViewCustomButton"/>.
        /// </returns>
        public static GridViewCustomButton GetDetailButton(string actionUrl)
        {
            return null;
        }
        #endregion

        #region actionresults
        /// <summary>
        /// Render parametergroup detail view.
        /// </summary>
        /// <param name="id">
        /// Parametergroup id.
        /// </param>
        /// <returns>
        /// Partial view.
        /// </returns>
        [AjaxOrChildActionOnly]
        public virtual ActionResult ParameterGroupDetail(Guid id)
        {
            return null;
        }
        #endregion

        #endregion
    }
}