﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseSampleController.CleanUpModelForValidation.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;

    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.Security;

    #endregion

    /// <summary>
    /// This partial class provides functions to set default values to the model
    /// is used for the short sample form, if we don't set this values the client model validation fails.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Laboratory)]
    public partial class BaseSampleController : BaseGridViewCustomBindingController
    {
        #region constants
        /// <summary>
        /// The placeholderstring.
        /// </summary>
        private const string PLACEHOLDERSTRING = "---";

        /// <summary>
        /// The placeholderdate.
        /// </summary>
        public readonly DateTime PLACEHOLDERDATE = DateHelper.PLACEHOLDERDATE;
        #endregion

        #region methods
        /// <summary>
        /// Clean up labNumber.
        /// </summary>
        /// <param name="labNumber">
        /// LabNumber.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanUpLabNumberForValidation(string labNumber)
        {
            return null;
        }

        /// <summary>
        /// Clean up manufacturer.
        /// </summary>
        /// <param name="manufacturer">
        /// Manufacturer.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanUpManufacturerForValidation(string manufacturer)
        {
            return null;
        }

        /// <summary>
        /// Clean up lot number.
        /// </summary>
        /// <param name="lotNumber">
        /// LotNumber.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanUpLotNumberForValidation(string lotNumber)
        {
            return null;
        }

        /// <summary>
        /// Clean up size type.
        /// </summary>
        /// <param name="sizeType">
        /// SizeType.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanUpSizeTypeForValidation(string sizeType)
        {
            return null;
        }

        /// <summary>
        /// Clean up lab entry date.
        /// </summary>
        /// <param name="labEntryDate">
        /// The lab Entry Date.
        /// </param>
        /// <param name="dateCanBeNull">
        /// The date Can Be Null.
        /// </param>
        /// <returns>
        /// The <see cref="DateTime?"/>.
        /// </returns>
        public DateTime? cleanUpLabEntryDateForValidation(DateTime? labEntryDate, bool dateCanBeNull)
        {
            return null;
        }

        /// <summary>
        /// Clean up report date.
        /// </summary>
        /// <param name="reportDate">
        /// ReportDate.
        /// </param>
        /// <param name="dateCanBeNull">
        /// The date Can Be Null.
        /// </param>
        /// <returns>
        /// The <see cref="DateTime?"/>.
        /// </returns>
        public DateTime? cleanUpReportDateForValidation(DateTime? reportDate, bool dateCanBeNull)
        {
            return null;
        }

        /// <summary>
        /// Clean up sampling date.
        /// </summary>
        /// <param name="samplingDate">
        /// SamplingDate.
        /// </param>
        /// <param name="dateCanBeNull">
        /// The date Can Be Null.
        /// </param>
        /// <returns>
        /// The <see cref="DateTime?"/>.
        /// </returns>
        public DateTime? cleanUpSamplingDateForValidation(DateTime? samplingDate, bool dateCanBeNull)
        {
            return null;
        }

        /// <summary>
        /// Clean up company.
        /// </summary>
        /// <param name="companyId">
        /// CompanyId.
        /// </param>
        /// <returns>
        /// The <see cref="Guid?"/>.
        /// </returns>
        public Guid? cleanUpCompanyForValidation(Guid? companyId)
        {
            return null;
        }

        /// <summary>
        /// Clean up country.
        /// </summary>
        /// <param name="country">
        /// Country.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpCountryForValidation(Guid country)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up farming type.
        /// </summary>
        /// <param name="farmingType">
        /// The farming Type.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpFarmingTypeForValidation(Guid farmingType)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up offer form.
        /// </summary>
        /// <param name="offerForm">
        /// OfferForm.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpOfferFormForValidation(Guid offerForm)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up bio product type.
        /// </summary>
        /// <param name="bioProductType">
        /// BioProductType.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpBioProductTypeForValidation(Guid bioProductType)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up brand marketing norm.
        /// </summary>
        /// <param name="brandMarketingNormId">
        /// The brand Marketing Norm Id.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpBrandMarketingNormForValidation(Guid brandMarketingNormId)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up sample type.
        /// </summary>
        /// <param name="sampleType">
        /// SampleType.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpSampleTypeForValidation(Guid sampleType)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up sample kind.
        /// </summary>
        /// <param name="sampleKindId">
        /// SampleKindId.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpSampleKindForValidation(Guid sampleKindId)
        {
            return new Guid();
        }

        /// <summary>
        /// If SampleKindInfo is NOT any of the kinds defined here, it is emptied.
        /// </summary>
        /// <param name="sampleKindInfo">
        /// </param>
        /// <param name="sampleKindId">
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanUpSampleKindInfoForValidation(string sampleKindInfo, Guid sampleKindId)
        {
            return null;
        }

        /// <summary>
        /// Clean up brand type.
        /// </summary>
        /// <param name="brandTypeId">
        /// BrandTypeId.
        /// </param>
        /// <returns>
        /// The <see cref="Guid?"/>.
        /// </returns>
        public Guid? cleanUpBrandTypeForValidation(Guid? brandTypeId)
        {
            return null;
        }

        /// <summary>
        /// Clean up private brand.
        /// </summary>
        /// <param name="brandTypeId">
        /// BrandTypeId.
        /// </param>
        /// <param name="privateBrandId">
        /// PrivateBrandId.
        /// </param>
        /// <returns>
        /// The <see cref="Guid?"/>.
        /// </returns>
        public Guid? cleanUpPrivateBrandForValidation(Guid? brandTypeId, Guid? privateBrandId)
        {
            return null;
        }

        /// <summary>
        /// The cleanup other brand for validation.
        /// </summary>
        /// <param name="brand">
        /// The brand.
        /// </param>
        /// <param name="brandTypeId">
        /// The brand type id.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string cleanupOtherBrandForValidation(string brand, Guid? brandTypeId)
        {
            return null;
        }

        /// <summary>
        /// Clean up sampler user.
        /// </summary>
        /// <param name="samplerUser">
        /// SamplerUser.
        /// </param>
        /// <returns>
        /// The <see cref="Guid?"/>.
        /// </returns>
        public Guid? cleanUpSamplerUserForValidation(Guid? samplerUser)
        {
            return null;
        }

        /// <summary>
        /// Clean up product.
        /// </summary>
        /// <param name="productId">
        /// ProductId.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpProductForValidation(Guid productId)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up sample examination.
        /// </summary>
        /// <param name="sampleExaminationId">
        /// SampleExamination.
        /// </param>
        /// <returns>
        /// The <see cref="Guid"/>.
        /// </returns>
        public Guid cleanUpSampleExaminationForValidation(Guid sampleExaminationId)
        {
            return new Guid();
        }

        /// <summary>
        /// The cleanup sample examination count for validation.
        /// </summary>
        /// <param name="sampleExaminationCount">
        /// The sample examination count.
        /// </param>
        /// <param name="sampleExaminationId">
        /// The sample examination id.
        /// </param>
        /// <returns>
        /// The <see cref="int"/>.
        /// </returns>
        public int cleanupSampleExaminationCountForValidation(int sampleExaminationCount, Guid sampleExaminationId)
        {
            return 0;
        }

        /// <summary>
        /// Add the psm to model
        /// psm is true, if there are no plant protection products detectable
        /// ratings with the property "DefaultExaminationAuto" are used to set this value
        /// all these ratings must be rated with GREEN!.
        /// </summary>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        /// <summary>
        /// Clear bioinstance if it isn't needed.
        /// </summary>
        /// <param name="bioProductType">
        /// BioProductType.
        /// </param>
        /// <param name="bioInstance">
        /// BioInstance.
        /// </param>
        /// <returns>
        /// </returns>
        public string cleanUpBioInstanceForValidation(Guid bioProductType, string bioInstance)
        {
            return null;
        }

        /// <summary>
        /// Clean up processing status
        /// </summary>
        /// <param name="processingStatusGuid"></param>
        /// <returns>Returns GuidNone if Guid was empty</returns>
        public Guid cleanUpProcessingStatusForValidation(Guid processingStatusGuid)
        {
            return new Guid();
        }

        /// <summary>
        /// Clean up intended use
        /// </summary>
        /// <param name="intendedUseGuid"></param>
        /// <returns>Returns GuidNone if Guid was empty</returns>
        public Guid cleanUpIntendedUseForValidation(Guid intendedUseGuid)
        {
            return new Guid();
        }
        #endregion
    }
}