﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseSampleController.Helper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;

    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Helper.Utility.ExtensionHelper;
    using Fruitmonitoring.Models;

    #endregion

    /// <summary>
    /// The base sample controller.
    /// </summary>
    public abstract partial class BaseSampleController : BaseGridViewCustomBindingController
    {
        #region Public Methods and Operators
        /// <summary>
        /// Get the next numeration item for textfields, memofields etc.
        /// </summary>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string GetNextFieldNumeration()
        {
            return null;
        }

        /// <summary>
        /// Reset the counter for field Numeration.
        /// </summary>
        public void ResetFieldNumeration()
        {
        }
        #endregion

        #region Methods
        /// <summary>
        /// Generates the CertificationBusiness xml for the SP.
        /// </summary>
        /// <param name="ids">
        /// All guids as an string array.
        /// </param>
        /// <returns>
        /// Xml.
        /// </returns>
        protected string generateCertificationBusinessXml(string[] ids)
        {
            return null;
        }

        /// <summary>
        /// Generates the CertificationProduct xml for the SP.
        /// </summary>
        /// <param name="ids">
        /// All guids as an string array.
        /// </param>
        /// <returns>
        /// Xml.
        /// </returns>
        protected string generateCertificationProductXml(string[] ids)
        {
            return null;
        }

        /// <summary>
        /// Generates the CertificationQualitySeal xml for the SP.
        /// </summary>
        /// <param name="ids">
        /// All guids as an string array.
        /// </param>
        /// <returns>
        /// Xml.
        /// </returns>
        protected string generateCertificationQualitySealXml(string[] ids)
        {
            return null;
        }

        /// <summary>
        /// Generates the retailer xml for the SP.
        /// </summary>
        /// <param name="ids">
        /// All guids as an string array.
        /// </param>
        /// <returns>
        /// Xml.
        /// </returns>
        protected string generateRetailerXml(string[] ids)
        {
            return null;
        }

        /// <summary>
        /// Get all certification business ids from users listbox selection.
        /// </summary>
        /// <returns>
        /// Array that holds all ids.
        /// </returns>
        protected string[] getCertificationBusinessSelectionIds()
        {
            return _listBoxExtensionHelper.GetSelectedValues<string>(dde_lb_certification_business_name);
        }

        /// <summary>
        /// Builds the complete certification business xml depending on the users selection in the form.
        /// </summary>
        /// <param name="certificationBusinessSelectionIds">
        /// The certification Business Selection Ids.
        /// </param>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected string getCertificationBusinessXml(string[] certificationBusinessSelectionIds)
        {
            return null;
        }

        /// <summary>
        /// Get all certification product ids from users listbox selection.
        /// </summary>
        /// <returns>
        /// Array that holds all ids.
        /// </returns>
        protected string[] getCertificationProductSelectionIds()
        {
            return _listBoxExtensionHelper.GetSelectedValues<string>(dde_lb_certification_product_name);
        }

        /// <summary>
        /// Builds the complete certification product xml depending on the users selection in the form.
        /// </summary>
        /// <param name="certificationProductSelectionIds">
        /// The certification Product Selection Ids.
        /// </param>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected string getCertificationProductXml(string[] certificationProductSelectionIds)
        {
            return null;
        }

        /// <summary>
        /// Get all certification quality seal ids from users listbox selection.
        /// </summary>
        /// <returns>
        /// Array that holds all ids.
        /// </returns>
        protected string[] getCertificationQualitySealSelectionIds()
        {
            return _listBoxExtensionHelper.GetSelectedValues<string>(dde_lb_certification_qualityseals_name);
        }

        /// <summary>
        /// Builds the complete certification quality seal xml depending on the users selection in the form.
        /// </summary>
        /// <param name="certificationQualitySealSelectionIds">
        /// The certification Quality Seal Selection Ids.
        /// </param>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected string getCertificationQualitySealXml(string[] certificationQualitySealSelectionIds)
        {
            return null;
        }

        /// <summary>
        /// Get the "none" company object.
        /// </summary>
        /// <returns>
        /// The <see cref="USP_Company_Sel_Result"/>.
        /// </returns>
        protected USP_Company_Sel_Result getCompanyNone()
        {
            return null;
        }

        /// <summary>
        /// Get Region selection retialerCompanyId.
        /// </summary>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected Guid? getExaminedProductId()
        {
            return null;
        }

        /// <summary>
        /// Load all data for the examined products selection list.
        /// </summary>
        /// <param name="sampleId">
        /// Sample id.
        /// </param>
        /// <returns>
        /// List with all single elements for the combobox.
        /// </returns>
        protected List<USP_SingleElements_Sel_Result> GetExaminedProductsList(Guid sampleId)
        {
            return null;
        }

        /// <summary>
        /// Get Region selection retialerCompanyId.
        /// </summary>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected Guid getRegionSelectionId()
        {
            return new Guid();
        }

        /// <summary>
        /// Get Region selection name.
        /// </summary>
        /// <returns>
        /// Region name.
        /// </returns>
        protected string getRegionSelectionName()
        {
            return null;
        }

        /// <summary>
        /// Load all data for the regions selection list.
        /// </summary>
        /// <param name="selectedRetailerIds">
        /// Selected retailer guids (separated by DbGuidHelper.JQUERYLISTSEPARATOR).
        /// </param>
        /// <returns>
        /// List with all regions.
        /// </returns>
        protected List<USP_Company_Sel_Result> GetRegionsList(string selectedRetailerIds = "")
        {
            return null;
        }

        /// <summary>
        /// Get all retailer ids from useres checkboxlist selection.
        /// </summary>
        /// <returns>
        /// Array that holds all ids.
        /// </returns>
        protected string[] getRetailerSelectionIds()
        {
            return _checkBoxListExtensionHelper.GetSelectedValues<string>(cbl_retailer_name);
        }

        /// <summary>
        /// Builds the complete retailer xml depending on the users selection in the form.
        /// </summary>
        /// <param name="selectedRetailerIds">
        /// The selected Retailer Ids.
        /// </param>
        /// <returns>
        /// Xml for the SP.
        /// </returns>
        protected string getRetailerXml(string[] selectedRetailerIds)
        {
            return null;
        }
        #endregion

        #region variables

        // combobox name of the examined ingredients selection
        /// <summary>
        /// The cb_examined_product_name.
        /// </summary>
        public static readonly string cb_examined_product_name = "cb_examined_product_name";

        // combobox name of the region selection
        /// <summary>
        /// The cb_regions_name.
        /// </summary>
        public static readonly string cb_regions_name = "cb_regions_name";

        // checkbox-list name of the retailer selection
        /// <summary>
        /// The cbl_retailer_name.
        /// </summary>
        public static readonly string cbl_retailer_name = "cb_retailer_name";

        // dropdown edit quality seals name
        /// <summary>
        /// The dde_lb_certification_qualityseals_name.
        /// </summary>
        public static readonly string dde_lb_certification_qualityseals_name = "dde_lb_certification_qualityseals_name";

        // dropdown edit business name
        /// <summary>
        /// The dde_lb_certification_business_name.
        /// </summary>
        public static readonly string dde_lb_certification_business_name = "dde_lb_certification_business_name";

        // dropdown edit product name
        /// <summary>
        /// The dde_lb_certification_product_name.
        /// </summary>
        public static readonly string dde_lb_certification_product_name = "dde_lb_certification_product_name";

        // checkbox defaultexamination-add-standard-ratings
        /// <summary>
        /// The btn_defaultexamination_add_standard_ratings_name.
        /// </summary>
        public static readonly string btn_defaultexamination_add_standard_ratings_name = "btn_defaultexamination_add_standard_ratings_name";

        // numeration for the sample form
        /// <summary>
        /// The field numeration.
        /// </summary>
        private int fieldNumeration = 0;

        // variables for testing  get original functionality without mocking
        /// <summary>
        /// The _check box list extension helper.
        /// </summary>
        private readonly ICheckBoxListExtensionHelper _checkBoxListExtensionHelper = new CheckBoxListExtensionHelper();

        /// <summary>
        /// The _list box extension helper.
        /// </summary>
        private readonly IListBoxExtensionHelper _listBoxExtensionHelper = new ListBoxExtensionHelper();

        /// <summary>
        /// The _combo box extension.
        /// </summary>
        private readonly IComboBoxExtensionHelper _comboBoxExtension = new ComboBoxExtensionHelper();
        #endregion
    }
}