﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseSampleDetailController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;
    using System.Web.Mvc;

    using DevExpress.Data;

    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The base sample detail controller.
    /// </summary>
    public abstract partial class BaseSampleDetailController : BaseSampleController
    {
        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="BaseSampleDetailController"/> class.
        /// </summary>
        /// <param name="bindingHandler">
        /// The binding handler.
        /// </param>
        /// <param name="gridViewId">
        /// The grid view id.
        /// </param>
        /// <param name="gridViewPartialPath">
        /// The grid view partial path.
        /// </param>
        /// <param name="keyFieldName">
        /// The key field name.
        /// </param>
        /// <param name="activeControllerName">
        /// The active controller name.
        /// </param>
        /// <param name="defaultSortColumn">
        /// The default sort column.
        /// </param>
        /// <param name="defaultSortColumnSortOrder">
        /// The default sort column sort order.
        /// </param>
        public BaseSampleDetailController(
            IBindingHandler bindingHandler,
            string gridViewId,
            string gridViewPartialPath,
            string keyFieldName,
            string activeControllerName,
            string defaultSortColumn,
            ColumnSortOrder defaultSortColumnSortOrder)
            : base(bindingHandler, gridViewId, gridViewPartialPath, keyFieldName, activeControllerName, defaultSortColumn, defaultSortColumnSortOrder)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseSampleDetailController"/> class.
        /// </summary>
        /// <param name="bindingHandler">
        /// The binding handler.
        /// </param>
        /// <param name="gridViewId">
        /// The grid view id.
        /// </param>
        /// <param name="gridViewPartialPath">
        /// The grid view partial path.
        /// </param>
        /// <param name="keyFieldName">
        /// The key field name.
        /// </param>
        /// <param name="activeControllerName">
        /// The active controller name.
        /// </param>
        public BaseSampleDetailController(
            IBindingHandler bindingHandler,
            string gridViewId,
            string gridViewPartialPath,
            string keyFieldName,
            string activeControllerName)
            : base(bindingHandler, gridViewId, gridViewPartialPath, keyFieldName, activeControllerName)
        {
        }
        #endregion

        #region actionresults
        /// <summary>
        /// The sample detail tab view.
        /// </summary>
        /// <param name="id">
        /// The id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public abstract ActionResult SampleDetailTabView(Guid id);

        /// <summary>
        /// The sample details print view.
        /// </summary>
        /// <param name="id">
        /// The id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public abstract ActionResult SampleDetailsPrintView(Guid id);
        #endregion
    }
}