﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="ErrorController.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.General
{
    #region usings
    using System;
    using System.Linq;
    using System.Net;
    using System.Text.RegularExpressions;
    using System.Web.Mvc;

    using Fruitmonitoring.Models.Error;

    #endregion

    /// <summary>
    /// The error controller.
    /// </summary>
    public class ErrorController : BaseController
    {
        #region Public Methods and Operators
        /// <summary>
        /// View for error page.
        /// </summary>
        /// <param name="statusCode">
        /// Error status code.
        /// </param>
        /// <param name="exception">
        /// Exception object.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public ActionResult Index(int statusCode, Exception exception)
        {
            return null;
        }

        /// <summary>
        /// View for internal server error.
        /// </summary>
        /// <param name="httpError">
        /// Error model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public ActionResult InternalServerError(HttpError httpError)
        {
            return null;
        }

        /// <summary>
        /// View for page not found.
        /// </summary>
        /// <param name="httpError">
        /// Error model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        public ActionResult PageNotFound(HttpError httpError)
        {
            return null;
        }
        #endregion

        #region Methods
        /// <summary>
        /// Generates the message that will be shown to the client.
        /// </summary>
        /// <param name="statusCode">The status code.</param>
        /// <param name="message">The error message.</param>
        /// <returns>The formated error message.</returns>
        private string generateResponseError(int statusCode, string message)
        {
            return null;
        }

        /// <summary>
        /// Get the current user name.
        /// </summary>
        /// <returns></returns>
        private string getUserName()
        {
            return null;
        }
        #endregion
    }
}