﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="IExportController.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Interfaces
{
    #region usings
    using System.Web.Mvc;

    #endregion

    /// <summary>
    /// The ExportController interface.
    /// </summary>
    public interface IExportController
    {
        #region Public Methods and Operators
        /// <summary>
        /// Implement this function to provide export functionalities
        /// this function is called by an ajax request initialized by the export popup which can be included over the fruitmonitoring-extensions-factory.
        /// </summary>
        /// <param name="exportType">
        /// Type of the export.
        /// </param>
        /// <param name="columnNames">
        /// Names of all columnNamesArray (separated by "[,]").
        /// </param>
        /// <param name="columnTexts">
        /// Texts of all columnNamesArray (separated by "[,]").
        /// </param>
        /// <param name="filter">
        /// Gridview filter expression.
        /// </param>
        /// <param name="sortColumnName">
        /// Sorted column name.
        /// </param>
        /// <param name="sortOrder">
        /// Sort order "Descending" or "Ascending".
        /// </param>
        /// <param name="applySorting">
        /// Use active sorting?.
        /// </param>
        /// <param name="applyFilter">
        /// Use active filtering?.
        /// </param>
        /// <returns>
        /// Excel file.
        /// </returns>
        ActionResult Export(
            string exportType,
            string columnNames,
            string columnTexts,
            string filter,
            string sortColumnName,
            string sortOrder,
            bool applySorting,
            bool applyFilter);
        #endregion
    }
}