﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="DocumentDownloadLaboratoryController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Laboratory.Dashboard
{
    #region usings
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;

    #endregion

    /// <summary>
    /// The document download laboratory controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.Laboratory)]
    public class DocumentDownloadLaboratoryController : BaseGridViewController
    {
        #region Properties

        #region Fields
        private readonly string gridViewPartialFile = "Documents/_documentsGridViewPartial";
        #endregion

        #endregion

        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentDownloadLaboratoryController"/> class.
        /// </summary>
        public DocumentDownloadLaboratoryController()
            : base(GridViewHelper.DOCUMENTDOWNLOADLABORATORYCONTROLLER, GridViewHelper.FILEUPLOADGRIDVIEWID, false, true)
        {
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public override ActionResult GridViewListView()
        {
            return null;
        }

        /// <summary>
        /// Load empty documents gridview.
        /// </summary>
        /// <returns></returns>
        [AjaxOrChildActionOnly]
        public override ActionResult GridViewListViewInit()
        {
            return null;
        }
        #endregion
    }
}