﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SampleLaboratoryBaseController.ModelHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Laboratory.Samples
{
    #region usings
    using System;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Controllers.Interfaces;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;

    #endregion

    /// <summary>
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Laboratory)]
    public partial class SampleLaboratoryBaseController : BaseSampleDetailController, IDataManipulator<USP_Sample_Sel_Result>
    {
        #region Public Methods and Operators
        /// <summary>
        /// clean up model if validation succeeds
        /// </summary>
        /// <param name="model">
        /// current model
        /// </param>
        /// <returns>
        /// </returns>
        public USP_Sample_Sel_Result CleanUpEditModelAfterValidation(USP_Sample_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// set this information to the "edit" model to get the modelstate valid
        /// This gets called From Edit().
        /// </summary>
        /// <param name="model">
        /// current model
        /// </param>
        /// <returns>
        /// current model with additional information
        /// </returns>
        public USP_Sample_Sel_Result CleanUpFinalEditModel(USP_Sample_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// remove some model values, that should not be saved to db
        /// </summary>
        /// <param name="model">
        /// </param>
        /// <returns>
        /// </returns>
        public USP_Sample_Sel_Result CleanUpModelForSP(USP_Sample_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// set this information to the "add"/"edit" model to get the modelstate valid
        /// This gets called from Add() and EditTemporary(), but not from Edit()
        /// </summary>
        /// <param name="model">
        /// current model
        /// </param>
        /// <returns>
        /// current model with additional information
        /// </returns>
        public USP_Sample_Sel_Result CleanUpModelForValidation(USP_Sample_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// clean up model that comes from webinterface
        /// </summary>
        /// <param name="model">
        /// sample model
        /// </param>
        /// <returns>
        /// model that is cleaned up
        /// </returns>
        public USP_Sample_Sel_Result CleanUpModelForWebInterface(USP_Sample_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// remove some needless default values for the edit form
        /// </summary>
        /// <param name="model">
        /// sample model
        /// </param>
        /// <returns>
        /// </returns>
        public USP_Sample_Sel_Result RemoveDefaultsFromSample(USP_Sample_Sel_Result model)
        {
            return null;
        }
        #endregion
    }
}