﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="AccountManagementRetailerController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Retailer.Administration
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The account management retailer controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.SuperUserRetailer | FruitmonitoringRoles.SuperUserRegion)]
    public class AccountManagementRetailerController : BaseGridViewCustomBindingController
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountManagementRetailerController"/> class.
        /// this constructor mustbe called from child class.
        /// </summary>
        public AccountManagementRetailerController()
            : base(
                new AccountBindingHandlers(),
                GridViewHelper.ACCOUNTMANAGERRETAILERGRIDVIEWID,
                GridViewHelper.GRIDVIEWCOMPONENTSPATH + "AccountManagement/_accountmanagementGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Account.Account_id),
                GridViewHelper.ACCOUNTMANAGERRETAILERCONTROLLERNAME,
                new USP_Account_Sel_Result().GetType(),
                false,
                false)
        {
        }
        #endregion

        #region Public Methods and Operators

        #region override members
        /// <summary>
        /// The custom binding core.
        /// </summary>
        /// <param name="gridViewModel">
        /// The grid view model.
        /// </param>
        /// <param name="sortColumn">
        /// The sort column.
        /// </param>
        /// <param name="oldPageSize">
        /// The old page size.
        /// </param>
        /// <returns>
        /// The <see cref="PartialViewResult"/>.
        /// </returns>
        public override PartialViewResult CustomBindingCore(GridViewModel gridViewModel, GridViewColumnState sortColumn = null, int oldPageSize = -1)
        {
            return null;
        }
        #endregion

        #endregion

        #region Methods

        #region Helper Member
        /// <summary>
        /// Authorized user specific filter.
        /// </summary>
        /// <returns>
        /// Filter to collect Users from own company and associated companys.
        /// </returns>
        private string getFixedFilterExpression()
        {
            return null;
        }
        #endregion

        #endregion
    }
}