#region Copyright  convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="ParameterGroupRetailerController.cs.cs" company="convivo GmbH">
//    Copyright  2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Controllers.Retailer.Dashboard
{
    #region usings
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Controllers.Interfaces;
    using Fruitmonitoring.Helper.Export;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The parameter group retailer controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Retailer)]
    public class ParameterGroupRetailerController : BaseParameterGroupController, IExportController
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="ParameterGroupRetailerController"/> class.
        /// </summary>
        public ParameterGroupRetailerController()
            : base(
                new ParameterGroupBindingHandlers(new Dictionary<string, object>() { { ParameterGroupBindingHandlers.PROPERTYKEY_USEUSERCOMPANYID, false } }),
                GridViewHelper.PARAMETERGROUPRETAILERGRIDVIEWID,
                GridViewHelper.GRIDVIEWCOMPONENTSPATH + "ParameterGroup/_parameterGroupRetailerGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_ParameterGroup.ParameterGroup_id),
                GridViewHelper.PARAMETERGROUPRETAILERCONTROLLERNAME)
        {
        }
        #endregion

        #region IExportController Members

        #region Public Methods and Operators

        #region IExportController Member
        /// <summary>
        /// The export.
        /// </summary>
        /// <param name="exportType">
        /// The export type.
        /// </param>
        /// <param name="columnNames">
        /// The column names.
        /// </param>
        /// <param name="columnTexts">
        /// The column texts.
        /// </param>
        /// <param name="filter">
        /// The filter.
        /// </param>
        /// <param name="sortColumnName">
        /// The sort column name.
        /// </param>
        /// <param name="sortOrder">
        /// The sort order.
        /// </param>
        /// <param name="applySorting">
        /// The apply sorting.
        /// </param>
        /// <param name="applyFilter">
        /// The apply filter.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        public ActionResult Export(
            string exportType,
            string columnNames,
            string columnTexts,
            string filter,
            string sortColumnName,
            string sortOrder,
            bool applySorting,
            bool applyFilter)
        {
            return null;
        }
        #endregion

        #endregion

        #endregion
    }
}