﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SampleSearchFieldDefinitions.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.AdvancedSearch
{
    #region usings
    using System.Collections.Generic;

    #endregion

    /// <summary>
    /// The sample search field definitions.
    /// </summary>
    public class SampleSearchFieldDefinitions
    {
        #region Properties
        /// <summary>
        /// Gets the searchfieldsanonymous.
        /// </summary>
        public static List<string> SEARCHFIELDSANONYMOUS
        {
            get
            {
                if (_searchFieldsAnonymous == null)
                {
                    _searchFieldsAnonymous = new List<string>();
                    _searchFieldsAnonymous.Add(LABENTRYDATE);
                    _searchFieldsAnonymous.Add(REPORTDATE);
                    _searchFieldsAnonymous.Add(SAMPLINGDATE);
                    _searchFieldsAnonymous.Add(RATING);
                    _searchFieldsAnonymous.Add(PRODUCT);
                    _searchFieldsAnonymous.Add(COUNTRY);
                    _searchFieldsAnonymous.Add(COUNTRYEU);
                    _searchFieldsAnonymous.Add(OFFERFORM);
                    _searchFieldsAnonymous.Add(SAMPLEKIND);
                    _searchFieldsAnonymous.Add(SAMPLETYPE);
                    _searchFieldsAnonymous.Add(SAMPLESTATUS);
                    _searchFieldsAnonymous.Add(FARMINGTYPE);
                    _searchFieldsAnonymous.Add(BIOPRODUCTTYPE);
                    _searchFieldsAnonymous.Add(PRODUCTNUMBER);
                    _searchFieldsAnonymous.Add(COUNTINGREDIENTS);
                    _searchFieldsAnonymous.Add(RATINGAREAS);
                    _searchFieldsAnonymous.Add(RATINGAREASRATING);
                    _searchFieldsAnonymous.Add(SAMPLERESULTSPARAMETER);
                    _searchFieldsAnonymous.Add(PROCESSINGSTATUS);
                    _searchFieldsAnonymous.Add(INTENDEDUSE);
                }

                return _searchFieldsAnonymous;
            }
        }

        /// <summary>
        /// Gets the searchfieldscomplete.
        /// </summary>
        public static List<string> SEARCHFIELDSCOMPLETE
        {
            get
            {
                if (_searchFieldsComplete == null)
                {
                    _searchFieldsComplete = new List<string>();
                    _searchFieldsComplete.Add(LABENTRYDATE);
                    _searchFieldsComplete.Add(REPORTDATE);
                    _searchFieldsComplete.Add(SAMPLINGDATE);
                    _searchFieldsComplete.Add(RATING);
                    _searchFieldsComplete.Add(PRODUCT);
                    _searchFieldsComplete.Add(COUNTRY);
                    _searchFieldsComplete.Add(COUNTRYEU);
                    _searchFieldsComplete.Add(OFFERFORM);
                    _searchFieldsComplete.Add(SAMPLEKIND);
                    _searchFieldsComplete.Add(SAMPLETYPE);
                    _searchFieldsComplete.Add(SAMPLESTATUS);
                    _searchFieldsComplete.Add(FARMINGTYPE);
                    _searchFieldsComplete.Add(BIOPRODUCTTYPE);
                    _searchFieldsComplete.Add(PRODUCTNUMBER);
                    _searchFieldsComplete.Add(COMPANYCLIENT);
                    _searchFieldsComplete.Add(COMPANYLABORATORY);
                    _searchFieldsComplete.Add(COMPANYSUPPLIER);
                    _searchFieldsComplete.Add(COUNTINGREDIENTS);
                    _searchFieldsComplete.Add(RATINGAREAS);
                    _searchFieldsComplete.Add(RATINGAREASRATING);
                    _searchFieldsComplete.Add(SAMPLERESULTSPARAMETER);
                    _searchFieldsComplete.Add(PROCESSINGSTATUS);
                    _searchFieldsComplete.Add(INTENDEDUSE);
                }

                return _searchFieldsComplete;
            }
        }
        #endregion

        #region Static Fields
        /// <summary>
        /// The bioproducttype.
        /// </summary>
        public static readonly string BIOPRODUCTTYPE = "BioProductType";

        /// <summary>
        /// The companyclient.
        /// </summary>
        public static readonly string COMPANYCLIENT = "CompanyClient";

        /// <summary>
        /// The companylaboratory.
        /// </summary>
        public static readonly string COMPANYLABORATORY = "CompanyLaboratory";

        /// <summary>
        /// The companysupplier.
        /// </summary>
        public static readonly string COMPANYSUPPLIER = "CompanySupplier";

        /// <summary>
        /// The countingredients.
        /// </summary>
        public static readonly string COUNTINGREDIENTS = "CountIngredients";

        /// <summary>
        /// The country.
        /// </summary>
        public static readonly string COUNTRY = "Country";

        /// <summary>
        /// The countryeu.
        /// </summary>
        public static readonly string COUNTRYEU = "CountryEu";

        /// <summary>
        /// The farmingtype.
        /// </summary>
        public static readonly string FARMINGTYPE = "FarmingType";

        // define unique search fields here. this fields are used for key value in db
        // we cannot use the db-fieldnames, because they can be changed sometimes
        /// <summary>
        /// The labentrydate.
        /// </summary>
        public static readonly string LABENTRYDATE = "LabEntryDate";

        /// <summary>
        /// The offerform.
        /// </summary>
        public static readonly string OFFERFORM = "OfferForm";

        /// <summary>
        /// The product.
        /// </summary>
        public static readonly string PRODUCT = "Product";

        /// <summary>
        /// The productnumber.
        /// </summary>
        public static readonly string PRODUCTNUMBER = "ProductNumber";

        /// <summary>
        /// The rating.
        /// </summary>
        public static readonly string RATING = "Rating";

        /// <summary>
        /// The ratingareas.
        /// </summary>
        public static readonly string RATINGAREAS = "RatingAreas";

        /// <summary>
        /// The ratingareasrating.
        /// </summary>
        public static readonly string RATINGAREASRATING = "RatingAreasRating";

        /// <summary>
        /// The ratingareasschema.
        /// </summary>
        public static readonly string RATINGAREASSCHEMA = "RatingAreasSchema";

        /// <summary>
        /// The reportdate.
        /// </summary>
        public static readonly string REPORTDATE = "ReportDate";

        /// <summary>
        /// The samplekind.
        /// </summary>
        public static readonly string SAMPLEKIND = "SampleKind";

        /// <summary>
        /// The sampleresultsparameter.
        /// </summary>
        public static readonly string SAMPLERESULTSPARAMETER = "SampleResultsParameter";

        /// <summary>
        /// The samplestatus.
        /// </summary>
        public static readonly string SAMPLESTATUS = "SampleStatus";

        /// <summary>
        /// The sampletype.
        /// </summary>
        public static readonly string SAMPLETYPE = "SampleType";

        /// <summary>
        /// The samplingdate.
        /// </summary>
        public static readonly string SAMPLINGDATE = "SamplingDate";

        /// <summary>
        /// The processing status.
        /// </summary>
        public static readonly string PROCESSINGSTATUS = "ProcessingStatus";

        /// <summary>
        /// The intended use.
        /// </summary>
        public static readonly string INTENDEDUSE = "IntendedUse";

        /// <summary>
        /// The _search fields anonymous.
        /// </summary>
        private static List<string> _searchFieldsAnonymous;

        /// <summary>
        /// The _search fields complete.
        /// </summary>
        private static List<string> _searchFieldsComplete;
        #endregion
    }
}