﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="BaseAdvancedSearch.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.AdvancedSearch
{
    #region usings
    using System.Collections.Generic;

    using Fruitmonitoring.Helper.Utility;

    #endregion

    /// <summary>
    /// The base advanced search.
    /// </summary>
    public abstract class BaseAdvancedSearch
    {
        #region Static Fields
        /// <summary>
        /// The comboboxnumberprefix.
        /// </summary>
        public static readonly string COMBOBOXNUMBERPREFIX = "NUMBERPREFIX";

        /// <summary>
        /// The companynameglnprefix.
        /// </summary>
        public static readonly string COMPANYNAMEGLNPREFIX = "GLN";

        /// <summary>
        /// The countingredientsto.
        /// </summary>
        public static readonly string COUNTINGREDIENTSTO = "COUNTINGREDIENTSTO";

        // needed to add unique devexpress components name 
        /// <summary>
        /// The datepickerprefi x 1.
        /// </summary>
        public static readonly string DATEPICKERPREFIX1 = "1";

        /// <summary>
        /// The datepickerprefi x 2.
        /// </summary>
        public static readonly string DATEPICKERPREFIX2 = "2";

        /// <summary>
        /// The datetoseparator.
        /// </summary>
        public static readonly string DATETOSEPARATOR = "-";
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// Returns a user friendly string for contains.
        /// </summary>
        /// <param name="propertyName">
        /// </param>
        /// <param name="propertyValue">
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string FormatContains(string propertyName, string propertyValue)
        {
            return null;
        }

        /// <summary>
        /// Returns a user friendly string for data greater-or-equal.
        /// </summary>
        /// <param name="propertyName">
        /// Property name.
        /// </param>
        /// <param name="propertyValue">
        /// Property value.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string FormatDateGE(string propertyName, string propertyValue)
        {
            return null;
        }

        /// <summary>
        /// Returns a user friendly string for data lighter-or-equal.
        /// </summary>
        /// <param name="propertyName">
        /// Property name.
        /// </param>
        /// <param name="propertyValue">
        /// Property value.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string FormatDateLE(string propertyName, string propertyValue)
        {
            return null;
        }

        /// <summary>
        /// Returns a user friendly string for equals.
        /// </summary>
        /// <param name="propertyName">
        /// </param>
        /// <param name="propertyValue">
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string FormatEquals(string propertyName, string propertyValue)
        {
            return null;
        }

        /// <summary>
        /// Returns a user friendly string for lists.
        /// </summary>
        /// <param name="propertyName">
        /// Property name.
        /// </param>
        /// <param name="propertyValues">
        /// List of all values.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string FormatIn(string propertyName, IEnumerable<string> propertyValues)
        {
            return null;
        }
        #endregion
    }
}