﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CommonPopupSubmitButtonExtension.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.CommonPopupSubmitButton
{
    #region usings
    using System.Web.Mvc;
    using System.Web.Mvc.Html;

    using Languages.Components;

    #endregion

    /// <summary>
    /// Provides functions to build the html "CommonPopupSubmitButton"
    /// the button submits the current form
    /// this button works only with ajax!.
    /// </summary>
    public class CommonPopupSubmitButtonExtension
    {
        #region Public Methods and Operators

        #region methods
        /// <summary>
        /// Builds the "CommonPopupSubmitButton" button.
        /// </summary>
        /// <param name="htmlHelper">
        /// </param>
        /// <param name="buttonText">
        /// Buttons caption. provide an emtpy string to get default caption.
        /// </param>
        /// <param name="callbackFunctionInit">
        /// A javascript callback before ajax start.
        /// </param>
        /// <param name="callbackFunctionSucceed">
        /// A javascript callback on ajax succeed.
        /// </param>
        /// <param name="callbackFunctionError">
        /// A javascript callback on js validation failed.
        /// </param>
        /// <param name="buttonName">
        /// Unique identifier for the button.
        /// </param>
        /// <param name="routeValues">
        /// Route data that should send to the server (not in use!).
        /// </param>
        /// <param name="validateForm">
        /// Enable/disable client side validation.
        /// </param>
        /// <param name="customActionURL">
        /// Provide a custom action url (different from forms action url).
        /// </param>
        /// <returns>
        /// The "CommonPopupSubmitButton" button html.
        /// </returns>
        public MvcHtmlString CreateCommonPopupSubmitButton(
            HtmlHelper htmlHelper,
            string buttonText,
            string callbackFunctionInit,
            string callbackFunctionSucceed,
            string callbackFunctionError,
            string buttonName,
            object routeValues = null,
            bool validateForm = true,
            string customActionURL = "")
        {
            return null;
        }
        #endregion

        #endregion
    }
}