﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CompanySelectionExtension.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.CompanySelection
{
    #region usings
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;
    using System.Web.Mvc.Html;

    using Fruitmonitoring.Helper.Utility;

    #endregion

    /// <summary>
    /// Provides functions to build the html company selection popup
    /// the button opens a new popup to where you can choose a company.
    /// </summary>
    public class CompanySelectionExtension
    {
        #region Public Methods and Operators

        #region methods
        /// <summary>
        /// Builds the "CompanySelection" popup.
        /// </summary>
        /// <param name="htmlHelper">
        /// </param>
        /// <param name="modelPropertyName">
        /// Name of the model property, that should bind to the company selection.
        /// </param>
        /// <param name="modelPropertyValue">
        /// Value of the model proterty.
        /// </param>
        /// <param name="companyTypes">
        /// Company types, that should be show in the gridview.
        /// </param>
        /// <param name="canAdministrate">
        /// User can add new companies?.
        /// </param>
        /// <param name="onlyActiveCompanies">
        /// Show only active companies.
        /// </param>
        /// <returns>
        /// The "CompanySelection" popup html.
        /// </returns>
        public MvcHtmlString CreateCompanySelection(
            HtmlHelper htmlHelper,
            string modelPropertyName,
            string modelPropertyValue,
            List<DbGuidHelper.CompanyTypes> companyTypes,
            bool canAdministrate,
            bool onlyActiveCompanies)
        {
            return null;
        }
        #endregion

        #endregion
    }
}