﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SupplierCompanySelectionController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.CompanySelection
{
    #region usings
    using System.Web.Mvc;

    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The supplier company selection controller.
    /// </summary>
    public class SupplierCompanySelectionController : BaseCompanySelectionController
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="SupplierCompanySelectionController"/> class.
        /// </summary>
        public SupplierCompanySelectionController()
            : base(
                new SupplierCompanyBindingHandlers(),
                GridViewHelper.SUPPLIERCOMPANYSELECTIONGRIDVIEWID,
                ExtensionsFactory.ComponentsPath + "/_supplierCompanySelectionGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Company2CompanyRights_InterSect.CompanyTo_id),
                GridViewHelper.SUPPLIERCOMPANYSELECTIONCONTROLLERNAME,
                new USP_Company2CompanyRights_InterSect_Result().GetType(),
                false,
                false)
        {
        }
        #endregion

        #region Methods
        /// <summary>
        /// The add retailers to dictionary.
        /// </summary>
        /// <param name="retailersList">
        /// The retailers list.
        /// </param>
        private void addRetailersToDictionary(string retailersList)
        {
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The custom filtering supplier selection.
        /// </summary>
        /// <param name="filterState">
        /// The filterState.
        /// </param>
        /// <param name="additionalCompanyTypeFilter">
        /// The additional company type filter.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <param name="canAdministrate">
        /// The can administrate.
        /// </param>
        /// <param name="onlyActiveCompanies">
        /// The only active companies.
        /// </param>
        /// <param name="retailersList">
        /// The retailers list.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomFilteringSupplierSelection(
            GridViewFilteringState filterState,
            string additionalCompanyTypeFilter,
            string modelPropertyValue,
            string modelPropertyName,
            bool canAdministrate,
            bool onlyActiveCompanies = true,
            string retailersList = null)
        {
            return null;
        }

        /// <summary>
        /// The custom paging supplier selection.
        /// </summary>
        /// <param name="pager">
        /// The pager.
        /// </param>
        /// <param name="additionalCompanyTypeFilter">
        /// The additional company type filter.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <param name="canAdministrate">
        /// The can administrate.
        /// </param>
        /// <param name="onlyActiveCompanies">
        /// The only active companies.
        /// </param>
        /// <param name="retailersList">
        /// The retailers list.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomPagingSupplierSelection(
            GridViewPagerState pager,
            string additionalCompanyTypeFilter,
            string modelPropertyValue,
            string modelPropertyName,
            bool canAdministrate,
            bool onlyActiveCompanies = true,
            string retailersList = null)
        {
            return null;
        }

        /// <summary>
        /// The custom sorting supplier selection.
        /// </summary>
        /// <param name="column">
        /// The column.
        /// </param>
        /// <param name="reset">
        /// The reset.
        /// </param>
        /// <param name="additionalCompanyTypeFilter">
        /// The additional company type filter.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <param name="canAdministrate">
        /// The can administrate.
        /// </param>
        /// <param name="onlyActiveCompanies">
        /// The only active companies.
        /// </param>
        /// <param name="retailersList">
        /// The retailers list.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomSortingSupplierSelection(
            GridViewColumnState column,
            bool reset,
            string additionalCompanyTypeFilter,
            string modelPropertyValue,
            string modelPropertyName,
            bool canAdministrate,
            bool onlyActiveCompanies = true,
            string retailersList = null)
        {
            return null;
        }

        /// <summary>
        /// The grid view list view supplier selection.
        /// </summary>
        /// <param name="additionalCompanyTypeFilter">
        /// The additional company type filter.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <param name="canAdministrate">
        /// The can administrate.
        /// </param>
        /// <param name="onlyActiveCompanies">
        /// The only active companies.
        /// </param>
        /// <param name="retailersList">
        /// The retailers list.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult GridViewListViewSupplierSelection(
            string additionalCompanyTypeFilter,
            string modelPropertyValue,
            string modelPropertyName,
            bool canAdministrate,
            bool onlyActiveCompanies = true,
            string[] retailersList = null)
        {
            return null;
        }
        #endregion
    }
}