﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CopyFieldValuesButtonExtension.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.CopyFieldValuesButton
{
    #region usings
    using System.Collections.Generic;
    using System.Web.Mvc;
    using System.Web.Mvc.Html;

    using Fruitmonitoring.Helper.Utility;

    #endregion

    /// <summary>
    /// Provides functions to build the html "back" button.
    /// </summary>
    public class CopyFieldValuesButtonExtension
    {
        #region Public Methods and Operators

        #region methods
        /// <summary>
        /// Builds the "CopyFieldValuesButton" button.
        /// </summary>
        /// <param name="htmlHelper">
        /// </param>
        /// <param name="buttonName">
        /// Unique name of the button.
        /// </param>
        /// <param name="buttonText">
        /// Caption of the button.
        /// </param>
        /// <param name="sourceFieldNames">
        /// Field ids that holds the source strings that should be copied.
        /// </param>
        /// <param name="targetFieldNames">
        /// Ids of all fields, that should receive the copied texts.
        /// </param>
        /// <param name="jsFunction">
        /// Provide an additional immediate javascript function that is called, if the button is cliecked. (syntax: '(function(calledFunction();){}())'.
        /// </param>
        /// <param name="enabled">
        /// The enabled.
        /// </param>
        /// <returns>
        /// The "CopyFieldValuesButton" button html.
        /// </returns>
        public MvcHtmlString CreateCopyFieldValuesButton(
            HtmlHelper htmlHelper,
            string buttonName,
            string buttonText,
            List<string> sourceFieldNames,
            List<string> targetFieldNames,
            string jsFunction,
            bool enabled)
        {
            return null;
        }
        #endregion

        #endregion
    }
}