﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="ExportButtonExtension.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.ExportButton
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Web.Mvc;
    using System.Web.Mvc.Html;

    using Fruitmonitoring.Controllers.Interfaces;

    using Languages.Components;

    #endregion

    /// <summary>
    /// Provides functions to build the html "export" button
    /// the button opens a new popup to customize the excel export.
    /// </summary>
    public class ExportButtonExtension
    {
        #region Public Methods and Operators

        #region methods
        /// <summary>
        /// Builds the "export" button.
        /// </summary>
        /// <param name="htmlHelper">
        /// </param>
        /// <param name="controllerType">
        /// Type of the controller, which should handle the request.
        /// </param>
        /// <param name="gridViewId">
        /// Active gridview retialerCompanyId.
        /// </param>
        /// <param name="exportAction">
        /// The export Action.
        /// </param>
        /// <param name="buttonTitle">
        /// The button Title.
        /// </param>
        /// <param name="enableFilterOption">
        /// Enables filter option.
        /// </param>
        /// <param name="enableSortingOption">
        /// Enables sorting option.
        /// </param>
        /// <param name="jsVarsExportParams">
        /// Additional parameters that will be added to export.
        /// Provide names of JavaScript variables that will be read to runtime.
        /// </param>
        /// <returns>
        /// The "export" button html.
        /// </returns>
        public MvcHtmlString CreateExportButton(
            HtmlHelper htmlHelper,
            Type controllerType,
            string gridViewId,
            string exportAction = null,
            string buttonTitle = null,
            bool enableFilterOption = true,
            bool enableSortingOption = true,
            List<string> jsVarsExportParams = null)
        {
            return null;
        }
        #endregion

        #endregion
    }
}