﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="ExtensionHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Web;
    using System.Web.Mvc;

    #endregion

    /// <summary>
    /// The extension helper.
    /// </summary>
    public class ExtensionHelper
    {
        #region constants
        /// <summary>
        /// The defaultexportaction.
        /// </summary>
        public static readonly string DEFAULTEXPORTACTION = "Export";

        /// <summary>
        /// The defaultsortaction.
        /// </summary>
        public static readonly string DEFAULTSORTACTION = "Sort";

        /// <summary>
        /// The defaultperiodlistviewaction.
        /// </summary>
        public static readonly string DEFAULTPERIODLISTVIEWACTION = "PeriodListView";
        #endregion

        #region methods
        /// <summary>
        /// Check if a class implements an specific interface.
        /// </summary>
        /// <param name="classType">
        /// Type of the class which should implement an given interface.
        /// </param>
        /// <param name="interfaceType">
        /// Type of the interface that should be checked.
        /// </param>
        /// <returns>
        /// The <see cref="bool"/>.
        /// </returns>
        public bool HasInterface(Type classType, Type interfaceType)
        {
            return false;
        }

        /// <summary>
        /// Gets the name of the controller without the "controller" at the end.
        /// </summary>
        /// <param name="controllerType">
        /// Controller type.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string GetControllerName(Type controllerType)
        {
            return null;
        }

        /// <summary>
        /// The add info for popup rendering.
        /// </summary>
        /// <param name="key">
        /// The key.
        /// </param>
        /// <param name="viewData">
        /// The view data.
        /// </param>
        public static void AddInfoForPopupRendering(string key, ViewDataDictionary viewData)
        {
        }
        #endregion
    }
}