﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="ParameterSelectionController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.ParameterSelection
{
    #region usings
    using System.Web.Mvc;

    using DevExpress.Data.Filtering;
    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    /// <summary>
    /// The parameter selection controller.
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Orderer)]
    public class ParameterSelectionController : BaseGridViewCustomBindingController
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="ParameterSelectionController"/> class.
        /// </summary>
        public ParameterSelectionController()
            : base(
                new ParameterBindingHandlers(),
                GridViewHelper.PARAMETERSELECTIONGRIDVIEWID,
                ExtensionsFactory.ComponentsPath + "_parameterSelectionGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_Parameter.Parameter_id),
                GridViewHelper.PARAMETERSELECTIONCONTROLLERNAME,
                new USP_Parameter_Sel_Result().GetType(),
                false,
                false)
        {
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The custom binding core.
        /// </summary>
        /// <param name="gridViewModel">
        /// The grid view model.
        /// </param>
        /// <param name="sortColumn">
        /// The sort column.
        /// </param>
        /// <param name="oldPageSize">
        /// The old page size.
        /// </param>
        /// <returns>
        /// The <see cref="PartialViewResult"/>.
        /// </returns>
        [NonAction]
        public override PartialViewResult CustomBindingCore(GridViewModel gridViewModel, GridViewColumnState sortColumn = null, int oldPageSize = -1)
        {
            return null;
        }

        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public override ActionResult GridViewListView()
        {
            return null;
        }
        #endregion

        #region Methods
        /// <summary>
        /// The get fixed filter expression.
        /// </summary>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        private string getFixedFilterExpression()
        {
            return null;
        }

        /// <summary>
        /// The load additional view data.
        /// </summary>
        private void loadAdditionalViewData()
        {
        }
        #endregion
    }
}