﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SampleCommentsManagementController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.SampleCommentsManagement
{
    #region usings
    using System;
    using System.Linq;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;

    #endregion

    // interner oder Ajax aufgerufen grundsätzlich eingeloggte
    // Nur Retailer; 
    /// <summary>
    /// The sample comments management controller.
    /// </summary>
    public class SampleCommentsManagementController : BaseGridViewController
    {
        #region Constructors and Destructors

        #region
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleCommentsManagementController"/> class.
        /// constructor provides important informations to the view.
        /// </summary>
        /// <param name="controllerName">
        /// Name of the controller, which should handle the incomming gridview requests.
        /// </param>
        /// <param name="gridViewId">
        /// The unique gridview retialerCompanyId.
        /// </param>
        public SampleCommentsManagementController()
            : base(GridViewHelper.SAMPLECOMMENTSMANAGEMENTCONTROLLERNAME, GridViewHelper.SAMPLECOMMENTSMANAGEMENTGRIDVIEWID, false, false)
        {
        }
        #endregion

        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListView()
        {
            return null;
        }

        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListViewInit()
        {
            return null;
        }

        #region methods
        /// <summary>
        /// The load view data.
        /// </summary>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        [NonAction]
        public void loadViewData(Guid sampleId)
        {
        }
        #endregion

        #endregion

        #region
        /// <summary>
        /// The sample comments grid view list view.
        /// </summary>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult SampleCommentsGridViewListView(Guid sampleId)
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        [ValidateAntiForgeryToken]
        [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Retailer)]
        public ActionResult Add(USP_SampleComments_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// The delete.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Retailer)]
        public ActionResult Delete(USP_SampleComments_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        [ValidateAntiForgeryToken]
        [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Retailer)]
        public ActionResult Edit(USP_SampleComments_Sel_Result model)
        {
            return null;
        }
        #endregion
    }
}