﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SampleResultsManagementController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.SampleResultsManagement
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Web;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.ParameterHelp;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;

    using Languages;
    using Languages.ModelData.SampleResult;

    #endregion

    // interner oder Ajax aufgerufen grundsätzlich eingeloggte
    // Labor
    /// <summary>
    /// The sample results management controller.
    /// </summary>
    public class SampleResultsManagementController : BaseGridViewController
    {
        #region Properties

        #region Static Fields
        /// <summary>
        /// The measuredvaluename.
        /// </summary>
        public static readonly string MEASUREDVALUENAME = "measuredValueInput";
        #endregion

        #endregion

        #region Constructors and Destructors

        // interner oder Ajax aufgerufen grundsätzlich eingeloggte
        // Labor

        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleResultsManagementController"/> class.
        /// constructor provides important informations to the view.
        /// </summary>
        /// <param name="controllerName">
        /// Name of the controller, which should handle the incomming gridview requests.
        /// </param>
        /// <param name="gridViewId">
        /// The unique gridview retialerCompanyId.
        /// </param>
        public SampleResultsManagementController()
            : base(GridViewHelper.SAMPLERESULTSMANAGEMENTCONTROLLERNAME, GridViewHelper.SAMPLERESULTSMANAGEMENTGRIDVIEWID, false, false)
        {
        }
        #endregion

        #endregion

        #region actionresult
        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListView()
        {
            return null;
        }

        /// <summary>
        /// The grid view list view.
        /// </summary>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListViewInit()
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <param name="sampleId">
        /// The sample Id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult SampleResultGridViewListView(Guid sampleId)
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Add(USP_SampleResults_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// Override measuredvalue cast error with user readable error message.
        /// </summary>
        private void checkMeasuredValueModelErrors()
        {
        }

        /// <summary>
        /// The delete.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        public ActionResult Delete(USP_SampleResults_Sel_Result model, Guid sampleId)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(USP_SampleResults_Sel_Result model)
        {
            return null;
        }

        /// <summary>
        /// The load method drop down.
        /// </summary>
        /// <param name="sampleResult">
        /// The sample result.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        public ActionResult LoadMethodDropDown(USP_SampleResults_Sel_Result sampleResult)
        {
            return null;
        }
        #endregion

        #region methods
        /// <summary>
        /// Get delegate sp for add sample result.
        /// </summary>
        /// <param name="model">
        /// </param>
        /// <param name="accountGuid">
        /// Needed for sameple history
        /// </param>
        /// <returns>
        /// </returns>
        public DelegateAdd GetDelegateAdd(USP_SampleResults_Sel_Result model, Guid accountGuid)
        {
            return null;
        }

        /// <summary>
        /// The load view data.
        /// </summary>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        [NonAction]
        private void loadViewData(Guid sampleId)
        {
        }

        /// <summary>
        /// The load view data for form.
        /// </summary>
        /// <param name="sampleId">
        /// The sample id.
        /// </param>
        /// <param name="parameterGroupId">
        /// The parameter group id.
        /// </param>
        /// <param name="viewData">
        /// The view data.
        /// </param>
        public void loadViewDataForForm(Guid sampleId, Guid parameterGroupId, ViewDataDictionary viewData)
        {
        }

        /// <summary>
        /// The generate parameter detailts json.
        /// </summary>
        /// <param name="parameters">
        /// The parameters.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string GenerateParameterDetailtsJson(List<USP_Parameter_Sel_Result> parameters)
        {
            return null;
        }
        #endregion
    }
}