﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SamplerUserAddModel.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.SamplerUserManagement
{
    #region usings
    using System;
    using System.ComponentModel.DataAnnotations;

    using Fruitmonitoring.Models;

    using Languages;

    using SamplerUser = Languages.ModelData.SamplerUser.SamplerUser;

    #endregion

    /// <summary>
    /// Use this model if you want to add an samplerUser via the sampler user management extension.
    /// </summary>
    public class SamplerUserAddModel : USP_SamplerUser_Sel_Result
    {
        #region Properties
        /// <summary>
        /// Gets or sets the company_id_ alias.
        /// </summary>
        [Required(AllowEmptyStrings = false, ErrorMessageResourceType = typeof(GlobalValidation), ErrorMessageResourceName = "Required")]
        [Display(ResourceType = typeof(SamplerUser), Name = "Company")]
        public Guid Company_id_Alias
        {
            get
            {
                return Company_id;
            }

            set
            {
                Company_id = value;
            }
        }
        #endregion

        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="SamplerUserAddModel"/> class.
        /// </summary>
        public SamplerUserAddModel()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SamplerUserAddModel"/> class.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        public SamplerUserAddModel(USP_SamplerUser_Sel_Result model)
        {
        }
        #endregion
    }
}