﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SamplerUserManagementController.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.SamplerUserManagement
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Web.Mvc;
    using System.Web.Script.Serialization;

    using DevExpress.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.AccessRules;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.BindingHandlers;

    #endregion

    // interner oder Ajax aufgerufen grundsätzlich eingeloggte
    // Theoretisch nur Labor
    /// <summary>
    /// The sampler user management controller.
    /// </summary>
    public class SamplerUserManagementController : BaseGridViewCustomBindingController
    {
        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// Initializes a new instance of the <see cref="SamplerUserManagementController"/> class.
        /// constructor provides important informations to the view.
        /// </summary>
        /// <param name="controllerName">
        /// Name of the controller, which should handle the incomming gridview requests.
        /// </param>
        /// <param name="gridViewId">
        /// The unique gridview sampler user id.
        /// </param>
        public SamplerUserManagementController()
            : base(
                new SamplerUserBindingHandlers(),
                GridViewHelper.SAMPLERUSERMANAGEMENTGRIDVIEWID,
                ExtensionsFactory.ComponentsPath + "/_samplerUserManagementGridViewPartial",
                CustomMetadataProvider.GetMemberName(() => EFHelper.Usp_SamplerUser.SamplerUser_id),
                GridViewHelper.SAMPLERUSERMANAGEMENTCONTROLLERNAME,
                new USP_SamplerUser_Sel_Result().GetType(),
                true,
                false)
        {
        }
        #endregion

        #endregion

        #region actionresults
        /// <summary>
        /// The grid view list view sampler user management.
        /// </summary>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult GridViewListViewSamplerUserManagement(string modelPropertyValue, string modelPropertyName)
        {
            return null;
        }

        /// <summary>
        /// The custom paging sampler user management.
        /// </summary>
        /// <param name="pager">
        /// The pager.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomPagingSamplerUserManagement(GridViewPagerState pager, string modelPropertyValue, string modelPropertyName)
        {
            return null;
        }

        /// <summary>
        /// The custom sorting sampler user management.
        /// </summary>
        /// <param name="column">
        /// The column.
        /// </param>
        /// <param name="reset">
        /// The reset.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomSortingSamplerUserManagement(GridViewColumnState column, bool reset, string modelPropertyValue, string modelPropertyName)
        {
            return null;
        }

        /// <summary>
        /// The custom filtering sampler user management.
        /// </summary>
        /// <param name="filterState">
        /// The filterState.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult CustomFilteringSamplerUserManagement(
            GridViewFilteringState filterState,
            string modelPropertyValue,
            string modelPropertyName)
        {
            return null;
        }

        /// <summary>
        /// The add.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Add(SamplerUserAddModel model, string modelPropertyValue, string modelPropertyName)
        {
            return null;
        }

        /// <summary>
        /// The edit.
        /// </summary>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        /// <returns>
        /// The <see cref="ActionResult"/>.
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(SamplerUserAddModel model, string modelPropertyValue, string modelPropertyName)
        {
            return null;
        }
        #endregion

        #region methods
        /// <summary>
        /// Get the sampler user's name and company for a given sampler user id.
        /// </summary>
        /// <param name="samplerUserId">
        /// The sampler User Id.
        /// </param>
        /// <returns>
        /// Sampler user' first name, last name, and company name as JS serialized string.
        /// </returns>
        public string GetSamplerUserNameByRowId(Guid samplerUserId)
        {
            return null;
        }

        /// <summary>
        /// The load additional view data.
        /// </summary>
        /// <param name="modelPropertyValue">
        /// The model property value.
        /// </param>
        /// <param name="modelPropertyName">
        /// The model property name.
        /// </param>
        public void loadAdditionalViewData(string modelPropertyValue, string modelPropertyName)
        {
        }

        /// <summary>
        /// Write all company types to viewdata that are allowed in company selection when adding a new sampler user.
        /// </summary>
        protected void LoadCompanySamplerData()
        {
        }

        /// <summary>
        /// Get the sampler user textfield text.
        /// </summary>
        /// <param name="firstName">
        /// Samplers firstname.
        /// </param>
        /// <param name="lastName">
        /// Samplers lastname.
        /// </param>
        /// <param name="companyName">
        /// Samplers companyname.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public static string GetSamplerUserTextFieldText(string firstName, string lastName, string companyName)
        {
            return null;
        }
        #endregion
    }
}