﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="TranslationExtensionController.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.HtmlExtensions.TranslationCreator
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Web.Mvc;

    using Fruitmonitoring.Controllers.General;
    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Infrastructure.ActionAttributes;
    using Fruitmonitoring.Infrastructure.Security;
    using Fruitmonitoring.Models;

    #endregion

    // interner oder Ajax aufgerufen grundsätzlich eingeloggte
    /// <summary>
    /// </summary>
    [CustomAuthorize(AppRole = FruitmonitoringRoles.SuperAdmin | FruitmonitoringRoles.Admin)]
    public class TranslationExtensionController : BaseGridViewController
    {
        #region Constructors and Destructors

        #region constructors
        /// <summary>
        /// constructor provides important informations to the view
        /// </summary>
        /// <param name="controllerName">name of the controller, which should handle the incomming gridview requests</param>
        /// <param name="gridViewId">the unique gridview retialerCompanyId</param>
        public TranslationExtensionController()
            : base(GridViewHelper.TRANSLATIONCREATORCONTROLLERNAME, string.Empty, false, false)
        {
        }
        #endregion

        #endregion

        #region actionresults
        /// <summary>
        /// </summary>
        /// <returns>
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListView()
        {
            return null;
        }

        /// <summary>
        /// </summary>
        /// <returns>
        /// </returns>
        /// <exception cref="NotImplementedException">
        /// </exception>
        [NonAction]
        public override ActionResult GridViewListViewInit()
        {
            return null;
        }

        /// <summary>
        /// get and set all data to render the translations gridview
        /// </summary>
        /// <param name="tableName">
        /// get translations for this table
        /// </param>
        /// <param name="columnName">
        /// get translations for this column
        /// </param>
        /// <param name="rowId">
        /// get translations for this retialerCompanyId
        /// </param>
        /// <param name="useBigTextBox">
        /// if true, the component renders a textarea instead of and textbox
        /// </param>
        /// <returns>
        /// </returns>
        [AjaxOrChildActionOnly]
        public ActionResult GridViewListViewExtended(string tableName, string columnName, Guid? rowId, bool useBigTextBox)
        {
            return null;
        }

        /// <summary>
        /// update translation
        /// </summary>
        /// <param name="model">
        /// model from the edit form
        /// </param>
        /// <param name="useBigTextBox">
        /// </param>
        /// <returns>
        /// </returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOrChildActionOnly]
        public ActionResult Edit(USP_Translation_Sel_Result model, bool useBigTextBox)
        {
            return null;
        }

        /// <summary>
        /// delete translation
        /// </summary>
        /// <param name="model">
        /// model from the gridview
        /// </param>
        /// <param name="tableName">
        /// get translations for this table
        /// </param>
        /// <param name="columnName">
        /// get translations for this column
        /// </param>
        /// <param name="useBigTextBox">
        /// </param>
        /// <returns>
        /// </returns>
        [HttpPost]
        [AjaxOrChildActionOnly]
        public ActionResult Delete(USP_Translation_Sel_Result model, string tableName, string columnName, bool useBigTextBox)
        {
            return null;
        }
        #endregion

        #region methods
        /// <summary>
        /// create an xml filter for the get translation SP
        /// </summary>
        /// <param name="tableName">
        /// get translations for this table
        /// </param>
        /// <param name="columnName">
        /// get translations for this column
        /// </param>
        /// <param name="rowId">
        /// get translations for this rowId
        /// </param>
        /// <returns>
        /// xml filter for the SP
        /// </returns>
        public static string GetFilterForTranslations(string tableName, string columnName, Guid? rowId)
        {
            return null;
        }

        /// <summary>
        /// create a xml filter for the get languages SP
        /// </summary>
        /// <returns>xml filter for the SP</returns>
        private string getFilterForLanguageDropDown()
        {
            return null;
        }
        #endregion
    }
}