﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SampleTransferUnsubscriber.cs.cs" company="convivo GmbH">
//    Copyright © 2015 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Modules.SampleTransferObservers
{
    #region usings
    using System;
    using System.Collections.Generic;

    #endregion

    /// <summary>
    /// The sample transfer unsubscriber.
    /// </summary>
    /// <typeparam name="SampleTransferInfo">
    /// </typeparam>
    internal class SampleTransferUnsubscriber<SampleTransferInfo> : IDisposable
    {
        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleTransferUnsubscriber{SampleTransferInfo}"/> class.
        /// </summary>
        /// <param name="observers">
        /// The observers.
        /// </param>
        /// <param name="observer">
        /// The observer.
        /// </param>
        internal SampleTransferUnsubscriber(List<IObserver<SampleTransferInfo>> observers, IObserver<SampleTransferInfo> observer)
        {
            _observers = observers;
            _observer = observer;
        }
        #endregion

        #region IDisposable Members

        #region Public Methods and Operators
        /// <summary>
        /// The dispose.
        /// </summary>
        public void Dispose()
        {
            if (_observers.Contains(_observer))
            {
                _observers.Remove(_observer);
            }
        }
        #endregion

        #endregion

        #region Fields
        /// <summary>
        /// The _observer.
        /// </summary>
        private readonly IObserver<SampleTransferInfo> _observer;

        /// <summary>
        /// The _observers.
        /// </summary>
        private readonly List<IObserver<SampleTransferInfo>> _observers;
        #endregion
    }
}