﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="PopupMenuItemCollection.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.PopupMenu
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text;
    using System.Xml.Serialization;

    #endregion

    /// <summary>
    /// The popup menu item collection.
    /// </summary>
    [Serializable]
    public class PopupMenuItemCollection
    {
        #region Properties

        #region Fields

        #region private variables
        /// <summary>
        /// List of PopupMenuItem objects.
        /// </summary>
        private readonly List<PopupMenuItem> _PopupMenuItemList = new List<PopupMenuItem>();
        #endregion

        #endregion

        #endregion

        #region Public Indexers
        /// <summary>
        /// Gets/Sets value for the item by that index.
        /// </summary>
        /// <param name="index">
        /// The index.
        /// </param>
        /// <returns>
        /// The <see cref="PopupMenuItem"/>.
        /// </returns>
        public PopupMenuItem this[int index]
        {
            get
            {
                return (PopupMenuItem)_PopupMenuItemList[index];
            }

            set
            {
                _PopupMenuItemList[index] = value;
            }
        }

        /// <summary>
        /// The this.
        /// </summary>
        /// <param name="customerItem">
        /// The customer item.
        /// </param>
        /// <returns>
        /// The <see cref="PopupMenuItem"/>.
        /// </returns>
        public PopupMenuItem this[PopupMenuItem customerItem]
        {
            get
            {
                return (PopupMenuItem)_PopupMenuItemList[customerItem.Index];
            }
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// Adds a new item to the collection.
        /// </summary>
        /// <param name="customerItem">
        /// The customer Item.
        /// </param>
        public void Add(PopupMenuItem customerItem)
        {
        }

        /// <summary>
        /// Searches for an item.
        /// </summary>
        /// <param name="customerItem">
        /// </param>
        /// <returns>
        /// The <see cref="bool"/>.
        /// </returns>
        public bool Contains(PopupMenuItem customerItem)
        {
            return false;
        }

        /// <summary>
        /// Implementation of enumerator.
        /// </summary>
        /// <returns>
        /// The <see cref="IEnumerator"/>.
        /// </returns>
        public IEnumerator<PopupMenuItem> GetEnumerator()
        {
            return null;
        }

        /// <summary>
        /// Returns item index.
        /// </summary>
        /// <param name="customerItem">
        /// </param>
        /// <returns>
        /// The <see cref="int"/>.
        /// </returns>
        public int IndexOf(PopupMenuItem customerItem)
        {
            return 0;
        }

        /// <summary>
        /// Inserts an item on a specific place.
        /// </summary>
        /// <param name="index">
        /// </param>
        /// <param name="customerItem">
        /// </param>
        public void Insert(int index, PopupMenuItem customerItem)
        {
        }

        /// <summary>
        /// Removes an item.
        /// </summary>
        /// <param name="customerItem">
        /// </param>
        public void Remove(PopupMenuItem customerItem)
        {
        }

        /*
		/// <summary>
		/// Returns PopupMenuItem list as xml for "BindToXML()"
		/// </summary>
		/// <returns></returns>
		public string ToXML() {
            return null;
		}		
*/

        /// <summary>
        /// Returns PopupMenuItem list as xml for "BindToXML()".
        /// </summary>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public string ToXML()
        {
            return null;
        }
        #endregion
    }

    #region helper class
    /// <summary>
    /// Workaround for a utf8 stringwriter.
    /// </summary>
    public class Utf8StringWriter : StringWriter
    {
        #region Properties
        /// <summary>
        /// Gets the encoding.
        /// </summary>
        public override Encoding Encoding
        {
            get
            {
                return Encoding.UTF8;
            }
        }
        #endregion
    }
    #endregion
}