﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="AccountHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System;

    #endregion

    /// <summary>
    /// The account helper.
    /// </summary>
    public class AccountHelper
    {
        #region Public Methods and Operators
        /// <summary>
        /// Creates a standardPassword.
        /// </summary>
        /// <returns>
        /// Random String with: 8 Character, min. one special char, min. one uppercase char, min. one lowercase char and min one number.
        /// </returns>
        public static string GeneratePassword()
        {
            const int passwordLength = 8;

            var allowedCharAll = "0123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ!§$%&/()=?";
            var allowedChar0 = "0123456789";
            var allowedChar1 = "abcdefghijkmnopqrstuvwxyz";
            var allowedChar2 = "ABCDEFGHJKLMNOPQRSTUVWXYZ";
            var allowedChar3 = "!§$%&/()=?";

            var randNumber = new Random();

            var chars = new char[passwordLength];

            chars[0] = allowedChar0[(int)(allowedChar0.Length * randNumber.NextDouble())];
            chars[1] = allowedChar1[(int)(allowedChar1.Length * randNumber.NextDouble())];
            chars[2] = allowedChar2[(int)(allowedChar2.Length * randNumber.NextDouble())];
            chars[3] = allowedChar3[(int)(allowedChar3.Length * randNumber.NextDouble())];

            for (int i = 4; i < passwordLength; i++)
            {
                chars[i] = allowedCharAll[(int)(allowedCharAll.Length * randNumber.NextDouble())];
            }

            return StringHelper.ShuffleString(new string(chars));
        }
        #endregion
    }
}