﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CompanyTypeFilterObject.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System.Text.RegularExpressions;

    #endregion

    /// <summary>
    /// Holds filter expression and company type ids.
    /// </summary>
    public class CompanyTypeFilterObject
    {
        #region Properties
        /// <summary>
        /// Gets the company type ids.
        /// </summary>
        public string CompanyTypeIds { get; private set; }

        /// <summary>
        /// Gets the filter expression.
        /// </summary>
        public string FilterExpression { get; private set; }
        #endregion

        #region Constructors and Destructors
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyTypeFilterObject"/> class.
        /// </summary>
        /// <param name="filter">
        /// The filter.
        /// </param>
        public CompanyTypeFilterObject(string filter)
        {
            extractCompanyTypeJoinedListFilter(filter);
        }
        #endregion

        #region Methods
        /// <summary>
        /// Extracts companyTypeId from filter expression so it can be put in AdditionalParameters. This is necessary due to the XML filter not being able to handle JoinedLists properly.
        /// Note: Currently only supports one company type, not a list of company types!.
        /// </summary>
        /// <param name="filterExpression">
        /// </param>
        private void extractCompanyTypeJoinedListFilter(string filterExpression)
        {
        }
        #endregion
    }
}