﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="CustomMetadataProvider.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.Linq.Expressions;
    using System.Web.Mvc;

    #endregion

    /// <summary>
    /// Provide a metadatabinder, so we can access the required Attribute depend on it's [Required] annotation
    /// call: ModelMetadataProviders.Current = new CustomMetadataProvider(); in the global.aspx (Application_Start)
    /// src: http://stackoverflow.com/questions/1662442/asp-net-mvc-modelmetadata-is-there-a-way-to-set-isrequired-based-on-the-require.
    /// </summary>
    public class CustomMetadataProvider : DataAnnotationsModelMetadataProvider
    {
        #region Methods
        /// <summary>
        /// The create metadata.
        /// </summary>
        /// <param name="attributes">
        /// The attributes.
        /// </param>
        /// <param name="containerType">
        /// The container type.
        /// </param>
        /// <param name="modelAccessor">
        /// The model accessor.
        /// </param>
        /// <param name="modelType">
        /// The model type.
        /// </param>
        /// <param name="propertyName">
        /// The property name.
        /// </param>
        /// <returns>
        /// The <see cref="ModelMetadata"/>.
        /// </returns>
        protected override ModelMetadata CreateMetadata(
            IEnumerable<Attribute> attributes,
            Type containerType,
            Func<object> modelAccessor,
            Type modelType,
            string propertyName)
        {
            return null;
        }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// Get the class name of an given object.
        /// </summary>
        /// <param name="obj">
        /// Object.
        /// </param>
        /// <returns>
        /// Name of the class.
        /// </returns>
        public static string GetClassName(object obj)
        {
            return null;
        }

        /// <summary>
        /// This function returns an membername of a class as a string.
        /// </summary>
        /// <typeparam name="T">
        /// </typeparam>
        /// <param name="memberExpression">
        /// Member of an object.
        /// </param>
        /// <returns>
        /// Membername as a string.
        /// </returns>
        public static string GetMemberName<T>(Expression<Func<T>> memberExpression)
        {
            return null;
        }
        #endregion
    }
}