﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="EFHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using Fruitmonitoring.Helper.HtmlExtensions.ProductSingleElementsManagement;
    using Fruitmonitoring.Models;
    using Fruitmonitoring.Models.ComboBox;
    using Fruitmonitoring.Models.ViewModels;

    #endregion

    /// <summary>
    /// This class holds dummy objects of all model classes
    /// use the dummys to get property names dynamically.
    /// </summary>
    public static class EFHelper
    {
        #region Static Fields
        /// <summary>
        /// </summary>
        public static readonly Company Company = new Company();

        /// <summary>
        /// </summary>
        public static readonly Sample Sample = new Sample();

        /// <summary>
        /// </summary>
        public static readonly SingleElements SingleElements = new SingleElements();

        // DB Table Models
        /// <summary>
        /// The certification business.
        /// </summary>
        public static CertificationBusiness CertificationBusiness = new CertificationBusiness();

        /// <summary>
        /// The certification product.
        /// </summary>
        public static CertificationProduct CertificationProduct = new CertificationProduct();

        /// <summary>
        /// The certification quality seal.
        /// </summary>
        public static CertificationQualitySeal CertificationQualitySeal = new CertificationQualitySeal();

        /// <summary>
        /// The company type filter.
        /// </summary>
        public static CompanyTypeFilter CompanyTypeFilter = new CompanyTypeFilter();

        /// <summary>
        /// The country.
        /// </summary>
        public static Country Country = new Country();

        /// <summary>
        /// The country filter.
        /// </summary>
        public static CountryFilter CountryFilter = new CountryFilter();

        /// <summary>
        /// The evaluation basis.
        /// </summary>
        public static EvaluationBasis EvaluationBasis = new EvaluationBasis();

        /// <summary>
        /// The measurement presetting.
        /// </summary>
        public static MeasurementPresetting MeasurementPresetting = new MeasurementPresetting();

        /// <summary>
        /// The method.
        /// </summary>
        public static Method Method = new Method();

        /// <summary>
        /// The news.
        /// </summary>
        public static News News = new News();

        /// <summary>
        /// The parameter.
        /// </summary>
        public static Parameter Parameter = new Parameter();

        /// <summary>
        /// The parameter ingredients.
        /// </summary>
        public static ParameterIngredients ParameterIngredients = new ParameterIngredients();

        /// <summary>
        /// The private brand company view model.
        /// </summary>
        public static PrivateBrandCompanyViewModel PrivateBrandCompanyViewModel = new PrivateBrandCompanyViewModel();

        /// <summary>
        /// The product.
        /// </summary>
        public static Product Product = new Product();

        /// <summary>
        /// The product group.
        /// </summary>
        public static ProductGroup ProductGroup = new ProductGroup();

        /// <summary>
        ///   The processing status.
        /// </summary>
        public static ProcessingStatus ProcessingStatus = new ProcessingStatus();
 
        /// <summary>
        ///   The intended use.
        /// </summary>
        public static IntendedUse IntendedUse = new IntendedUse();

        /// <summary>
        /// The product single elements management add model
        /// </summary>
        public static ProductSingleElementsManagementAddModel ProductSingleElementsManagementAddModel = new ProductSingleElementsManagementAddModel();

        /// <summary>
        /// The rating area.
        /// </summary>
        public static RatingArea RatingArea = new RatingArea();

        /// <summary>
        /// The rating filter.
        /// </summary>
        public static RatingFilter RatingFilter = new RatingFilter();

        /// <summary>
        /// The rating schema.
        /// </summary>
        public static RatingSchema RatingSchema = new RatingSchema();

        /// <summary>
        /// The sample cancellation comment validation.
        /// </summary>
        public static SampleCancellationCommentValidation SampleCancellationCommentValidation = new SampleCancellationCommentValidation();

        /// <summary>
        /// The sample result validation.
        /// </summary>
        public static SampleResultValidation SampleResultValidation = new SampleResultValidation();

        // Validation Models
        /// <summary>
        /// The sample validation.
        /// </summary>
        public static SampleValidation SampleValidation = new SampleValidation();

        /// <summary>
        /// The single elements validation.
        /// </summary>
        public static SingleElementValidation SingleElementsValidation = new SingleElementValidation();

        /// <summary>
        /// The usp_ account.
        /// </summary>
        public static USP_Account_Sel_Result Usp_Account = new USP_Account_Sel_Result();

        /// <summary>
        /// The usp_ bio product type.
        /// </summary>
        public static USP_BioProductType_Sel_Result Usp_BioProductType = new USP_BioProductType_Sel_Result();

        /// <summary>
        /// The usp_ brand marketing norm.
        /// </summary>
        public static USP_BrandMarketingNorm_Sel_Result Usp_BrandMarketingNorm = new USP_BrandMarketingNorm_Sel_Result();

        /// <summary>
        /// The usp_ brand type.
        /// </summary>
        public static USP_BrandType_Sel_Result Usp_BrandType = new USP_BrandType_Sel_Result();

        /// <summary>
        /// The usp_ certification business.
        /// </summary>
        public static USP_CertificationBusiness_Sel_Result Usp_CertificationBusiness = new USP_CertificationBusiness_Sel_Result();

        /// <summary>
        /// The usp_ certification product.
        /// </summary>
        public static USP_CertificationProduct_Sel_Result Usp_CertificationProduct = new USP_CertificationProduct_Sel_Result();

        /// <summary>
        /// The usp_ certification quality seal.
        /// </summary>
        public static USP_CertificationQualitySeal_Sel_Result Usp_CertificationQualitySeal = new USP_CertificationQualitySeal_Sel_Result();

        /// <summary>
        /// The usp_ company.
        /// </summary>
        public static USP_Company_Sel_Result Usp_Company = new USP_Company_Sel_Result();

        /// <summary>
        /// The usp_ company 2 company rights.
        /// </summary>
        public static USP_Company2CompanyRights_Sel_Result Usp_Company2CompanyRights = new USP_Company2CompanyRights_Sel_Result();

        // public static USP_SingleElementsInvestigationOrder_Sel_Result Usp_SingleElementsInvestigationOrde = new USP_SingleElementsInvestigationOrder_Sel_Result();
        /// <summary>
        /// The usp_ company 2 company rights_ inter sect.
        /// </summary>
        public static USP_Company2CompanyRights_InterSect_Result Usp_Company2CompanyRights_InterSect = new USP_Company2CompanyRights_InterSect_Result();

        /// <summary>
        /// The usp_ company status.
        /// </summary>
        public static USP_CompanyStatus_Sel_Result Usp_CompanyStatus = new USP_CompanyStatus_Sel_Result();

        /// <summary>
        /// The usp_ company type.
        /// </summary>
        public static USP_CompanyType_Sel_Result Usp_CompanyType = new USP_CompanyType_Sel_Result();

        // DB Stored Procedure Models
        /// <summary>
        /// The usp_ country.
        /// </summary>
        public static USP_Country_Sel_Result Usp_Country = new USP_Country_Sel_Result();

        /// <summary>
        /// The usp_ evaluation basis.
        /// </summary>
        public static USP_EvaluationBasis_Sel_Result Usp_EvaluationBasis = new USP_EvaluationBasis_Sel_Result();

        /// <summary>
        /// The usp_ farming type.
        /// </summary>
        public static USP_FarmingType_Sel_Result Usp_FarmingType = new USP_FarmingType_Sel_Result();

        /// <summary>
        /// The usp_ language.
        /// </summary>
        public static USP_Language_Sel_Result Usp_Language = new USP_Language_Sel_Result();

        /// <summary>
        /// The usp_ measurement presetting.
        /// </summary>
        public static USP_MeasurementPresetting_Sel_Result Usp_MeasurementPresetting = new USP_MeasurementPresetting_Sel_Result();

        /// <summary>
        /// The usp_ method.
        /// </summary>
        public static USP_Method_Sel_Result Usp_Method = new USP_Method_Sel_Result();

        /// <summary>
        /// The usp_ news.
        /// </summary>
        public static USP_News_Sel_Result Usp_News = new USP_News_Sel_Result();

        /// <summary>
        /// The usp_ offer form.
        /// </summary>
        public static USP_OfferForm_Sel_Result Usp_OfferForm = new USP_OfferForm_Sel_Result();

        /// <summary>
        /// The usp_ parameter.
        /// </summary>
        public static USP_Parameter_Sel_Result Usp_Parameter = new USP_Parameter_Sel_Result();

        /// <summary>
        /// The usp_ parameter group.
        /// </summary>
        public static USP_ParameterGroup_Sel_Result Usp_ParameterGroup = new USP_ParameterGroup_Sel_Result();

        /// <summary>
        /// The usp_ parameter group status.
        /// </summary>
        public static USP_ParameterGroupStatus_Sel_Result Usp_ParameterGroupStatus = new USP_ParameterGroupStatus_Sel_Result();

        /// <summary>
        /// The usp_ parameter ingredients.
        /// </summary>
        public static USP_ParameterIngredients_Sel_Result Usp_ParameterIngredients = new USP_ParameterIngredients_Sel_Result();

        /// <summary>
        /// The usp_ parameter type.
        /// </summary>
        public static USP_ParameterType_Sel_Result Usp_ParameterType = new USP_ParameterType_Sel_Result();

        /// <summary>
        /// The usp_ private brand.
        /// </summary>
        public static USP_PrivateBrand_Sel_Result Usp_PrivateBrand = new USP_PrivateBrand_Sel_Result();

        /// <summary>
        /// The usp_ product.
        /// </summary>
        public static USP_Product_Sel_Result Usp_Product = new USP_Product_Sel_Result();

        /// <summary>
        /// The usp_ product group.
        /// </summary>
        public static USP_ProductGroup_Sel_Result Usp_ProductGroup = new USP_ProductGroup_Sel_Result();

        /// <summary>
        /// The usp_ processing status.
        /// </summary>
        public static USP_ProcessingStatus_Sel_Result Usp_ProcessingStatus = new USP_ProcessingStatus_Sel_Result();

        /// <summary>
        /// The usp_ intended use
        /// </summary>
        public static USP_IntendedUse_Sel_Result Usp_IntendedUse = new USP_IntendedUse_Sel_Result();

        /// <summary>
        /// The usp_ rating.
        /// </summary>
        public static USP_Rating_Sel_Result Usp_Rating = new USP_Rating_Sel_Result();

        /// <summary>
        /// The usp_ rating area.
        /// </summary>
        public static USP_RatingArea_Sel_Result Usp_RatingArea = new USP_RatingArea_Sel_Result();

        /// <summary>
        /// The usp_ rating schema.
        /// </summary>
        public static USP_RatingSchema_Sel_Result Usp_RatingSchema = new USP_RatingSchema_Sel_Result();

        /// <summary>
        /// The usp_ sample.
        /// </summary>
        public static USP_Sample_Sel_Result Usp_Sample = new USP_Sample_Sel_Result();

        /// <summary>
        /// The usp_ sample_ big with results.
        /// </summary>
        public static USP_Sample_Sel_BigWithResults_Result Usp_Sample_BigWithResults = new USP_Sample_Sel_BigWithResults_Result();

        /// <summary>
        /// The usp_ sample_ investigation.
        /// </summary>
        public static USP_Sample_Investigation_Sel_Result Usp_Sample_Investigation = new USP_Sample_Investigation_Sel_Result();

        /// <summary>
        /// The usp_ sample_ investigation_ parameter.
        /// </summary>
        public static USP_SampleInvestigationParameter_Sel_Result Usp_Sample_Investigation_Parameter = new USP_SampleInvestigationParameter_Sel_Result();

        /// <summary>
        /// The usp_ sample 2 certification business.
        /// </summary>
        public static USP_Sample2CertificationBusiness_Sel_Result Usp_Sample2CertificationBusiness = new USP_Sample2CertificationBusiness_Sel_Result();

        /// <summary>
        /// The usp_ sample 2 certification product.
        /// </summary>
        public static USP_Sample2CertificationProduct_Sel_Result Usp_Sample2CertificationProduct = new USP_Sample2CertificationProduct_Sel_Result();

        /// <summary>
        /// The usp_ sample 2 certification quality seal.
        /// </summary>
        public static USP_Sample2CertificationQualitySeal_Sel_Result Usp_Sample2CertificationQualitySeal = new USP_Sample2CertificationQualitySeal_Sel_Result();

        /// <summary>
        /// The us p_ sample comments.
        /// </summary>
        public static USP_SampleComments_Sel_Result USP_SampleComments = new USP_SampleComments_Sel_Result();

        /// <summary>
        /// The usp_ sample documents.
        /// </summary>
        public static USP_SampleDocuments_Sel_Result Usp_SampleDocuments = new USP_SampleDocuments_Sel_Result();

        /// <summary>
        /// The usp_ sample examination.
        /// </summary>
        public static USP_SampleExamination_Sel_Result Usp_SampleExamination = new USP_SampleExamination_Sel_Result();

        /// <summary>
        /// The usp_ sample history.
        /// </summary>
        public static USP_SampleHistory_Sel_Result Usp_SampleHistory = new USP_SampleHistory_Sel_Result();

        /// <summary>
        /// The usp_ sample kind.
        /// </summary>
        public static USP_SampleKind_Sel_Result Usp_SampleKind = new USP_SampleKind_Sel_Result();

        /// <summary>
        /// The usp_ sample rating.
        /// </summary>
        public static USP_SampleRating_Sel_Result Usp_SampleRating = new USP_SampleRating_Sel_Result();

        /// <summary>
        /// The usp_ sample result.
        /// </summary>
        public static USP_SampleResults_Sel_Result Usp_SampleResult = new USP_SampleResults_Sel_Result();

        /// <summary>
        /// The usp_ sampler user.
        /// </summary>
        public static USP_SamplerUser_Sel_Result Usp_SamplerUser = new USP_SamplerUser_Sel_Result();

        /// <summary>
        /// The usp_ sample status.
        /// </summary>
        public static USP_SampleStatus_Sel_Result Usp_SampleStatus = new USP_SampleStatus_Sel_Result();

        /// <summary>
        /// The usp_ sample type.
        /// </summary>
        public static USP_SampleType_Sel_Result Usp_SampleType = new USP_SampleType_Sel_Result();

        /// <summary>
        /// The usp_ show private brands.
        /// </summary>
        public static USP_PrivateBrandShow_Sel_Result Usp_ShowPrivateBrands = new USP_PrivateBrandShow_Sel_Result();

        /// <summary>
        /// The usp_ single elements.
        /// </summary>
        public static USP_SingleElements_Sel_Result Usp_SingleElements = new USP_SingleElements_Sel_Result();

        /// <summary>
        /// The usp_ statistic_ laboratory budget.
        /// </summary>
        public static USPG_Statistics_LaboratoryBudget_Result Usp_Statistic_LaboratoryBudget = new USPG_Statistics_LaboratoryBudget_Result();

        /// <summary>
        /// The usp_ title.
        /// </summary>
        public static USP_Title_Sel_Result Usp_Title = new USP_Title_Sel_Result();

        /// <summary>
        /// The usp_ translation.
        /// </summary>
        public static USP_Translation_Sel_Result Usp_Translation = new USP_Translation_Sel_Result();

        /// <summary>
        /// The usp_ weight unit.
        /// </summary>
        public static USP_WeightUnit_Sel_Result Usp_WeightUnit = new USP_WeightUnit_Sel_Result();

        /// <summary>
        /// The usp g_ statistics_ laboratory budget.
        /// </summary>
        public static USPG_Statistics_LaboratoryBudget_Result USPG_Statistics_LaboratoryBudget = new USPG_Statistics_LaboratoryBudget_Result();

        /// <summary>
        /// The usp g_ statistics_ samples_ laboratory.
        /// </summary>
        public static USPG_Statistics_Samples_Laboratory_Result USPG_Statistics_Samples_Laboratory = new USPG_Statistics_Samples_Laboratory_Result();

        /// <summary>
        /// The usp g_ statistics_ samples_ laboratory 4 retailer.
        /// </summary>
        public static USPG_Statistics_Samples_Laboratory4Retailer_Result USPG_Statistics_Samples_Laboratory4Retailer =
            new USPG_Statistics_Samples_Laboratory4Retailer_Result();

        /// <summary>
        /// The weight unit.
        /// </summary>
        public static WeightUnit WeightUnit = new WeightUnit();
        #endregion
    }
}