﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="Emailer.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System;
    using System.IO;
    using System.Web.Hosting;

    using Fruitmonitoring.Helper.HtmlExtensions;
    using Fruitmonitoring.Helper.Utility.Email;
    using Fruitmonitoring.Helper.View;
    using Fruitmonitoring.Models;

    using log4net;

    using Languages.Emails;

    using RazorEngine;

    #endregion

    /// <summary>
    /// Modification of mailer from BaseController while no
    /// controller/view context exists for the ExaminationTasks.
    /// </summary>
    public class Emailer : IDisposable
    {
        #region Public Methods and Operators
        /// <summary>
        /// The dispose.
        /// </summary>
        public void Dispose()
        {
            if (_db != null)
            {
                _db.Dispose();
                _db = null;
            }
        }

        /// <summary>
        /// Send mail via database stored procedure.
        /// </summary>
        /// <param name="eMailOptions">
        /// </param>
        /// <param name="logger">
        /// The logger.
        /// </param>
        /// <returns>
        /// The <see cref="bool"/>.
        /// </returns>
        public bool SendMail(EMailOptions eMailOptions, ILog logger)
        {
            return false;
        }
        #endregion

        #region variables

        // database object
        /// <summary>
        /// The _db.
        /// </summary>
        private Entities _db;

        /// <summary>
        /// Gets the db.
        /// </summary>
        public Entities db
        {
            get
            {
                if (_db == null)
                {
                    _db = new Entities();
                }

                return _db;
            }
        }
        #endregion
    }
}