﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="RadioButtonListExtensionHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility.ExtensionHelper
{
    #region usings
    using DevExpress.Web.Mvc;

    #endregion

    /// <summary>
    /// The RadioButtonListExtensionHelper interface.
    /// </summary>
    public interface IRadioButtonListExtensionHelper
    {
        #region Public Methods and Operators
        /// <summary>
        /// The get value.
        /// </summary>
        /// <param name="formElementName">
        /// The form element name.
        /// </param>
        /// <typeparam name="T">
        /// </typeparam>
        /// <returns>
        /// The <see cref="T"/>.
        /// </returns>
        T GetValue<T>(string formElementName);
        #endregion
    }

    /// <summary>
    /// The radio button list extension helper.
    /// </summary>
    public class RadioButtonListExtensionHelper : IRadioButtonListExtensionHelper
    {
        #region IRadioButtonListExtensionHelper Members

        #region Public Methods and Operators
        /// <summary>
        /// The get value.
        /// </summary>
        /// <param name="formElementName">
        /// The form element name.
        /// </param>
        /// <typeparam name="T">
        /// </typeparam>
        /// <returns>
        /// The <see cref="T"/>.
        /// </returns>
        public T GetValue<T>(string formElementName)
        {
            return EditorExtension.GetValue<T>(formElementName);
        }
        #endregion

        #endregion
    }
}