﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="HtmlActionImage.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System.Text;
    using System.Web.Mvc;

    #endregion

    /// <summary>
    /// Provides an action-image link builder, which can be accessed by the mvc htmlHelper.
    /// </summary>
    public static class HtmlActionImage
    {
        #region methods
        /// <summary>
        /// Creates and Action link with a clickable image instead of text.
        /// </summary>
        /// <param name="helper">
        /// </param>
        /// <param name="controller">
        /// Controller.
        /// </param>
        /// <param name="action">
        /// Action.
        /// </param>
        /// <param name="parameters">
        /// Parameters.
        /// </param>
        /// <param name="src">
        /// Image source.
        /// </param>
        /// <param name="alt">
        /// Alternate text(Optional).
        /// </param>
        /// <param name="title">
        /// The title.
        /// </param>
        /// <param name="cssClassA">
        /// The css Class A.
        /// </param>
        /// <param name="cssClassImg">
        /// The css Class Img.
        /// </param>
        /// <param name="isLinkActive">
        /// Render image with link or without link functionality (Optional).
        /// </param>
        /// <returns>
        /// An HTML anchor tag with a nested image tag.
        /// </returns>
        public static MvcHtmlString ActionImage(
            this HtmlHelper helper,
            string controller,
            string action,
            object parameters,
            string src,
            string alt = "",
            string title = "",
            string cssClassA = "",
            string cssClassImg = "",
            bool isLinkActive = true)
        {
            return null;
        }

        /// <summary>
        /// Creates and Action link with a clickable image instead of text.
        /// On Click a JavaScript function is executed.
        /// </summary>
        /// <param name="helper">
        /// </param>
        /// <param name="jsFunction">
        /// Name of the javascript function which should be executed.
        /// </param>
        /// <param name="src">
        /// Image source.
        /// </param>
        /// <param name="alt">
        /// Alternate text(Optional).
        /// </param>
        /// <param name="title">
        /// The title.
        /// </param>
        /// <param name="cssClassA">
        /// The css Class A.
        /// </param>
        /// <param name="cssClassImg">
        /// The css Class Img.
        /// </param>
        /// <param name="isLinkActive">
        /// Render image with link or without link functionality (Optional).
        /// </param>
        /// <returns>
        /// An HTML anchor tag with a nested image tag.
        /// </returns>
        public static MvcHtmlString ActionImageJS(
            this HtmlHelper helper,
            string jsFunction,
            string src,
            string alt = "",
            string title = "",
            string cssClassA = "",
            string cssClassImg = "",
            bool isLinkActive = true)
        {
            return null;
        }
        #endregion
    }
}