﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="IDateHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility.Interfaces
{
    #region usings
    using System;

    #endregion

    /// <summary>
    /// The DateHelper interface.
    /// </summary>
    public interface IDateHelper
    {
        #region Properties
        /// <summary>
        /// Returns now.
        /// </summary>
        /// <returns>
        /// </returns>
        DateTime Now { get; }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// Calculate the first day of the current month.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetFirstDayOfCurrentMonth();

        /// <summary>
        /// Calculate the first day of the current year.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetFirstDayOfCurrentYear();

        /// <summary>
        /// Calculate the first day of the given year.
        /// </summary>
        /// <param name="year">
        /// Year "yyyy".
        /// </param>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetFirstDayOfCustomYear(int year);

        /// <summary>
        /// Calculate the first day of the last.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetFirstDayOfLastYear();

        /// <summary>
        /// Calculate the last day of the current month.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetLastDayOfCurrentMonth();

        /// <summary>
        /// Calculate the last day of the current year.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetLastDayOfCurrentYear();

        /// <summary>
        /// Calculate the last day of the given year.
        /// </summary>
        /// <param name="year">
        /// Year "yyyy".
        /// </param>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetLastDayOfCustomYear(int year);

        /// <summary>
        /// Calculate the last day of the last year.
        /// </summary>
        /// <returns>
        /// Datetime.
        /// </returns>
        DateTime GetLastDayOfLastYear();
        #endregion
    }
}