﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="StringHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2013 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Utility
{
    #region usings
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Web;
    using System.Xml;

    using Fruitmonitoring.Helper.Validation;

    #endregion

    /// <summary>
    /// The string helper.
    /// </summary>
    public class StringHelper
    {
        #region Public Methods and Operators
        /// <summary>
        /// Generates a "," separated list of strings that can be included as parameter in javascript "new Array()"
        /// the strings are encoded by "UrlEncode".
        /// </summary>
        /// <typeparam name="T">
        /// Type of objects in the list.
        /// </typeparam>
        /// <param name="list">
        /// List that holds the objects.
        /// </param>
        /// <param name="propertyName">
        /// Property name in the object that holds the string value.
        /// </param>
        /// <returns>
        /// A "," separated string of all elements. each element is surrounded by "".
        /// </returns>
        public static string GenerateArrayStringForJS<T>(List<T> list, string propertyName)
        {
            return null;
        }

        /// <summary>
        /// Removes invalid Emailaddressess from a comma separated List and transform List to a semicolon separated list.
        /// </summary>
        /// <param name="recipients">
        /// The recipients.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public static string GetEmailAddressesFromString(string recipients)
        {
            return null;
        }

        /// <summary>
        /// Checks if string contains well-formed XML.
        /// </summary>
        /// <param name="value">
        /// Value.
        /// </param>
        /// <returns>
        /// True when string is well-formed XML.
        /// </returns>
        public static bool IsValidXML(string value)
        {
            return false;
        }

        /// <summary>
        /// ShuffleString.
        /// </summary>
        /// <param name="text">
        /// String to shuffle.
        /// </param>
        /// <returns>
        /// Shuffled string.
        /// </returns>
        public static string ShuffleString(string text)
        {
            return null;
        }

        /// <summary>
        /// Generates a random string with the given length.
        /// </summary>
        /// <param name="size">
        /// Size of the string.
        /// </param>
        /// <param name="lowerCase">
        /// If true, generate lowercase string.
        /// </param>
        /// <returns>
        /// Random string.
        /// </returns>
        public string RandomString(int size, bool lowerCase)
        {
            var builder = new StringBuilder();
            var random = new Random();
            char ch;
            for (int i = 0; i < size; i++)
            {
                ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
                builder.Append(ch);
            }

            if (lowerCase)
            {
                return builder.ToString().ToLower();
            }

            return builder.ToString();
        }
        #endregion
    }
}