﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="SingleElementPortionMaximumReachedAttribute.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.Validation
{
    #region usings
    using System;
    using System.ComponentModel.DataAnnotations;
    using System.Globalization;
    using System.Linq;

    using Fruitmonitoring.Helper.Utility;
    using Fruitmonitoring.Models;

    #endregion

    /// <summary>
    /// Check if the all portions of the single elements in one sample don't overstep 100%.
    /// </summary>
    public class SingleElementPortionMaximumReachedAttribute : ValidationAttribute
    {
        #region Properties
        /// <summary>
        /// Gets or sets the sample id column name.
        /// </summary>
        public string SampleIDColumnName { get; set; }

        /// <summary>
        /// Gets or sets the single element id column name.
        /// </summary>
        public string SingleElementIDColumnName { get; set; }
        #endregion

        #region Public Methods and Operators
        /// <summary>
        /// Custom error message format.
        /// </summary>
        /// <param name="name">
        /// Name that is not valid.
        /// </param>
        /// <returns>
        /// Formatted error message.
        /// </returns>
        public override string FormatErrorMessage(string name)
        {
            return null;
        }
        #endregion

        #region Methods
        /// <summary>
        /// Check if the all portions of the single elements in one sample don't overstep 100%.
        /// </summary>
        /// <param name="value">
        /// Current validated value.
        /// </param>
        /// <param name="validationContext">
        /// Validation context.
        /// </param>
        /// <returns>
        /// Null if validation succeed, otherwise an Validation Result.
        /// </returns>
        protected override ValidationResult IsValid(object value, ValidationContext validationContext)
        {
            return null;
        }
        #endregion
    }
}