﻿#region Copyright © convivo GmbH
// ------------------------------------------------------------------------------------------------------------------------
// <copyright file="RenderViewHelper.cs.cs" company="convivo GmbH">
//    Copyright © 2014 convivo GmbH
// </copyright>
// <creator name="convivo GmbH"/>
// ------------------------------------------------------------------------------------------------------------------------
#endregion

namespace Fruitmonitoring.Helper.View
{
    #region usings
    using System;
    using System.IO;
    using System.Web;

    using RazorEngine;
    using RazorEngine.Templating;

    #endregion

    /// <summary>
    /// The render view helper.
    /// </summary>
    public class RenderViewHelper
    {
        #region Public Methods and Operators
        /// <summary>
        /// The map path.
        /// </summary>
        /// <param name="filePath">
        /// The file path.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public static string MapPath(string filePath)
        {
            return HttpContext.Current != null
                       ? HttpContext.Current.Server.MapPath(filePath)
                       : string.Format("{0}{1}", AppDomain.CurrentDomain.BaseDirectory, filePath.Replace("~", string.Empty).TrimStart('/'));
        }

        /// <summary>
        /// The render partial to string.
        /// </summary>
        /// <param name="viewPath">
        /// The view path.
        /// </param>
        /// <param name="model">
        /// The model.
        /// </param>
        /// <returns>
        /// The <see cref="string"/>.
        /// </returns>
        public static string RenderPartialToString(string viewPath, object model, DynamicViewBag viewBag = null)
        {
            string viewAbsolutePath = MapPath(viewPath);

            var viewSource = File.ReadAllText(viewAbsolutePath);

            string renderedText = Razor.Parse(viewSource, model, viewBag, null);
            return renderedText;
        }
        #endregion
    }
}